unit uMain;
interface
uses
 Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
 Dialogs, StdCtrls, ExtCtrls, Menus,MMSystem,ShellAPI, ImgList, ComCtrls,
 ToolWin,uLVcomp;
type
 TMainForm = class(TForm)
 TimerMain: TTimer; MainMenu1: TMainMenu;
 N1: TMenuItem; N2: TMenuItem; N3: TMenuItem; N4: TMenuItem;
 OpenDialogLvt: TOpenDialog;
 ResetCPU1: TMenuItem;
 N11: TMenuItem;
 procedure fillcharVideoDirty;
 procedure draw_screen1;
 procedure draw_screen2;
 Procedure SupCol2;
 Procedure My_col2;
 procedure col_index;
 procedure TimerMainTimer(Sender: TObject);
 procedure do_write(addr: Cardinal; bt: Cardinal);
 procedure i8080_init;
 function do_read(addr: Cardinal): Cardinal;
 procedure do_write2(a_lo: Cardinal; a_hi: Cardinal; bt: Cardinal);
 function do_read2(a_lo : Cardinal; a_hi : Cardinal): Cardinal;
 function do_input(port : Cardinal): Cardinal;
 procedure do_output(port : Cardinal; bt : Cardinal);
 procedure kbd(mask : word; press : boolean);
 procedure reset1;
 procedure load_bios;
 procedure do_pause();
 procedure i8080_do_opcodes(nb_cycles : Cardinal); //  
 procedure draw_screen();
 procedure FirstPusk;
 function readmask (keynum: word): word;
 procedure N4Click(Sender: TObject);
 procedure N2Click(Sender: TObject);
 procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
 procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
 procedure FormActivate(Sender: TObject);
 procedure NewLoadFile(filenameDnD: string;start : boolean);
 procedure ResetComp;
 procedure ResetCPU1Click(Sender: TObject);
 procedure FormCreate(Sender: TObject);
 procedure FormDestroy(Sender: TObject);
 procedure Wmemory; procedure Rmemory;
 procedure Wflags;  procedure Rflags;
 procedure Wvideo;  procedure Rvideo;
 procedure WVideoDirty; procedure RVideoDirty;
 procedure Wports; procedure Rports;
 procedure Wkbd_base; procedure Rkbd_base;
 procedure Wkbd_ext; procedure Rkbd_ext;
 private
 { Private declarations }
 public
 procedure WMDropFiles(var Msg: TMessage); message wm_DropFiles;
 { Public declarations }
 end;

var
 MainForm: TMainForm;

  VideoDirtyM : array [0..16384] of word; //   


 kbd_baseM : array [0..8] of byte; //   
 kbd_extM : array [0..4] of byte;//=(1,2,3,4,5);

 FPusk: boolean; //  
 gamecanvas: tbitmap; //       

 bios : array [0..65535] of byte; //    ,      
 Myfile: array [0..90000] of byte; //    DUMP SAV 

 pause : boolean; //  
// opcodes_to_run:Cardinal = round ((1411200*2)/50{FPS});
// FPS:Cardinal=50; opcodes_to_run:Cardinal = 68500;
 FPS:Cardinal=1000; opcodes_to_run:Cardinal = 68500;
 myfilelength: Cardinal; //   

 BasicStack,BasicHotEntry,BasicProgBegin,BasicProgEnd : Cardinal;

var LVColBlack:Cardinal=0; LVColLime:Cardinal=$00FF00; LVColBlue:Cardinal=$FF0000; LVColRed:Cardinal=$0000FF;
implementation
{$R *.dfm}
var Wmemory_a,Wmemory_b:Cardinal; procedure TMainForm.Wmemory; begin memoryM[Wmemory_a]:=Wmemory_b; end;
var Rmemory_a,Rmemory_result:Cardinal; procedure TMainForm.Rmemory; begin Rmemory_result:=memoryM[Rmemory_a];end;
var Wflags_a,Wflags_b:Cardinal; procedure TMainForm.Wflags; begin flagsM[Wflags_a]:=Wflags_b; end;
var Rflags_a,Rflags_result:Cardinal; procedure TMainForm.Rflags; begin Rflags_result:=flagsM[Rflags_a];end;
var Wvideo_a,Wvideo_b:Cardinal; procedure TMainForm.Wvideo; begin videoM[Wvideo_a]:=Wvideo_b; end;
var Rvideo_a,Rvideo_result:Cardinal; procedure TMainForm.Rvideo; begin Rvideo_result:=videoM[Rvideo_a];end;
var WVideoDirty_a,WVideoDirty_b:Cardinal; procedure TMainForm.WVideoDirty; begin VideoDirtyM[WVideoDirty_a]:=WVideoDirty_b; end;
var RVideoDirty_a,RVideoDirty_result:Cardinal; procedure TMainForm.RVideoDirty; begin RVideoDirty_result:=VideoDirtyM[RVideoDirty_a];end;
var Wports_a,Wports_b:Cardinal; procedure TMainForm.Wports; begin portsM[Wports_a]:=Wports_b; end;
var Rports_a,Rports_result:Cardinal; procedure TMainForm.Rports; begin Rports_result:=portsM[Rports_a];end;
var Wkbd_base_a,Wkbd_base_b:Cardinal; procedure TMainForm.Wkbd_base; begin kbd_baseM[Wkbd_base_a]:=Wkbd_base_b; end;
var Rkbd_base_a,Rkbd_base_result:Cardinal; procedure TMainForm.Rkbd_base; begin Rkbd_base_result:=kbd_baseM[Rkbd_base_a];end;
var Wkbd_ext_a,Wkbd_ext_b:Cardinal; procedure TMainForm.Wkbd_ext; begin kbd_extM[Wkbd_ext_a]:=Wkbd_ext_b; end;
var Rkbd_ext_a,Rkbd_ext_result:Cardinal; procedure TMainForm.Rkbd_ext; begin Rkbd_ext_result:=kbd_extM[Rkbd_ext_a];end;

procedure TMainForm.fillcharVideoDirty;
var c:Cardinal; begin {$R-} For c:=0 to 16384 do begin
Rvideo_a:=c; Rvideo; WVideoDirty_a:=c;WVideoDirty_b:=(Rvideo_result xor 1);WVideoDirty;{$R+} end; end;

procedure TMainForm.WMDropFiles(var Msg: TMessage); //      
var FileName: array[0..256] of char;
begin DragQueryFile(THandle(Msg.WParam), 0, FileName, SizeOf(Filename));
MainForm.Caption:=FileName;NewLoadFile(FileName,true);DragFinish(THandle(Msg.WParam));end;

procedure TMainForm.do_write(addr : Cardinal; bt : Cardinal); //     :-)
begin
 {$R-}
if addr> $FFFF then addr:=$FFFF;
 if (addr>=$C000) then
 begin exit; end;
Rports_a:=$C2;Rports; if ((Rports_result and 2)<>0) then begin Wmemory_A:=addr; Wmemory_B:=bt; Wmemory; end else
if (addr<$4000) then begin exit; end else
if (addr<$8000) then begin Wvideo_a:=(addr-$4000);Wvideo_b:=bt; Wvideo; end else
begin Wmemory_A:=addr; Wmemory_B:=bt; Wmemory; end;
 {$R+}
end;


procedure TMainForm.i8080_init;

var j,i : Cardinal;
begin
 {$R-}
for i:=0 to 255 do
 begin
 {flags[i]:=f1 or fP;} Wflags_a:=i;Wflags_b:=(f1 or fP);Wflags;
for j:=0 to 7 do
 begin
  if ((i and (1 SHL j))<>0) then
    begin
  { flags[i]:=(flags[i] xor fP);}
   Rflags_a:=i;Rflags;
  Wflags_a:=i;Wflags_b:=(Rflags_Result xor fP);Wflags;
    end;
  end;
 if ((i and $80)<>0) then
 begin
   { flags[i]:=(flags[i] or fS);}
     Rflags_a:=i;Rflags;
   Wflags_a:=i;Wflags_b:=(Rflags_Result or fS);Wflags;
    end;
  if (i=0) then
    begin
    { flags[i]:=(flags[i] or fZ);}
     Rflags_a:=i;Rflags;
   Wflags_a:=i;Wflags_b:=(Rflags_Result or fZ);Wflags;
    end;
 end;
 {$R+}
end;




function TMainForm.do_read(addr : Cardinal): Cardinal; //    
begin
 {$R-}
if addr> $FFFF then addr:=$FFFF;
RPorts_a:=$C2;RPorts; if ((RPorts_result and 2)<>0) then
 begin  Rmemory_A:=addr; Rmemory; result := Rmemory_result; end
 else if (addr>$7FFF) then begin  Rmemory_A:=addr; Rmemory; result := Rmemory_result; end
 else if (addr<$4000) then begin result := 0; end else
 begin Rvideo_a:=(addr-$4000); Rvideo; result := Rvideo_result; end;
 {$R+}
end;

procedure TMainForm.do_write2(a_lo: Cardinal; a_hi: Cardinal; bt: Cardinal);
begin {$R-} do_write(a_lo+(a_hi SHL 8),bt); {$R+}end;

function TMainForm.do_read2(a_lo : Cardinal; a_hi : Cardinal): Cardinal;
begin {$R-} result := do_read(a_lo+(a_hi SHL 8)); {$R+}end;


function TMainForm.do_input(port : Cardinal): Cardinal; //     in
var i,r : Cardinal; nD2 ,nD0 : Cardinal;
begin
 {$R-}
 port:=$C0+(port and $13);
 case port of
 $C2:  begin Rports_a:=$C2;Rports; result := Rports_result; end;
 $D1:  begin Rports_a:=$D0;Rports; nD0:=not Rports_result; r:=0;
    For i:=0 to 7 do
    begin
    if ((nD0 and (1 SHL i))<>0) then begin rkbd_base_a:=i;rkbd_base; r:=(r or Rkbd_base_result); end;
    end;
    result := ((not r) and $FF);
   end;
 $D2: begin Rports_a:=$D2;Rports; nD2:= not Rports_result; r:=0;
   for i:=0 to 3 do begin if ((nD2 and (1 SHL i))<>0) then begin Rkbd_ext_a:=i;Rkbd_ext; r:=(r or Rkbd_ext_result);end;
    end;
    result := not ((r SHL 4) or (nD2 and $0F)) and $FF;
   end
  else begin result := $FF; end;
end;
 {$R+}
end;

procedure TMainForm.do_output(port : Cardinal; bt : Cardinal); // out
begin
 {$R-}
 port:=$C0+(port and $13);
 case port of
 $c1: begin //   
   fillcharVideoDirty;
  end;

 end;
 Wports_a:=port;Wports_b:=bt; Wports;
  {$R+}
end ;

procedure TMainForm.kbd(mask : word; press : boolean); //     
var brow : byte; erow : byte; bcol : byte; ecol : byte;
begin
  {$R-}
 bcol:=(mask SHR 12) and $0F; brow:=(mask SHR 8) and $0F;
 ecol:=(mask SHR 4) and $0F; erow:=(mask SHR 0) and $0F;
 if ((brow<8) and (bcol<8)) then
 begin
 if (press) then begin Rkbd_base_a:=bcol;Rkbd_base;
  Wkbd_base_a:=bcol;Wkbd_base_b:=(Rkbd_base_result or (1 SHL brow));Wkbd_base; end
  else begin Rkbd_base_a:=bcol;Rkbd_base;
   Wkbd_base_a:=bcol;Wkbd_base_b:=(Rkbd_base_result and (not(1 SHL brow))); Wkbd_base; end;
 end;
 if ((erow<8) and (ecol<4)) then begin Rkbd_ext_a:=ecol;Rkbd_ext;
 if (press) then begin  Wkbd_ext_a:=ecol;Wkbd_ext_b:= (Rkbd_ext_result or (1 SHL erow));Wkbd_ext;
 end else begin Rkbd_ext_a:=ecol;Rkbd_ext; Wkbd_ext_a:=ecol;Wkbd_ext_b:=(Rkbd_ext_result and (not(1 SHL erow)));Wkbd_ext; end;
 end;
  {$R+}
end;

procedure TMainForm.reset1; //   :)
var i : word; begin {$R-} for i:=0 to 255 do begin
 Wports_a:=i;Wports_b:=$FF; Wports; end; {$R+} end;

procedure TMainForm.load_bios; //    
var i: Cardinal;b: Byte;f: file of byte;
begin
 {$R-}
 i:=0; AssignFile(F,ExtractFilePath(Application.ExeName)+'\bios.dat');
 Reset(F); while not eof(f) do begin read(F,b); bios[i]:=b; inc(i); end;
 closeFile(F); i:=0;
 for i:=0 to $3FFF do begin Wmemory_a:=($C000+i);Wmemory_b:=bios[22+i];Wmemory; end;
 {$R+}
end;

procedure TMainForm.N2Click(Sender: TObject);
begin
 OpenDialogLvt.InitialDir:=ExtractFilePath(Application.ExeName);
 if OpenDialogLvt.Execute then NewLoadFile(OpenDialogLvt.FileName,true);
end;

procedure TMainForm.N4Click(Sender: TObject);
begin gamecanvas.Free;close;end;

procedure TMainForm.NewLoadFile(filenameDnD: string; start : boolean); //    
var f:file of byte; b:Byte; s: string; posBas, Xend ,Xbeg ,Xrun : word; i: integer;
begin
 {$R-}
 s:='';
 AssignFile(f,filenameDnD); //    
  Reset(f);
 for I:= 0 to 8 do begin  read(f,b);   s:=s+chr(b);  end;
 if s='LVOV/2.0/' then //  LVT 
  begin   read(f,b);
   if b=$D0 then  {  }   begin
   seek(F,0); //    
   i:=0;
   while not eof(f) do
   begin read(F,b); Myfile[i]:=b; inc(i); end;
   myfilelength:=i;
   closeFile(F);  // 
   Xbeg:=Myfile[16]+Myfile[17]*256;   Xend:=Myfile[18]+Myfile[19]*256;
   Xrun:=Myfile[20]+Myfile[21]*256;
   if (start) then begin {warm_start();} rgPC:=Xrun; end;
   i:=0;
   while (i<=Xend-Xbeg) do begin do_write(Xbeg+i,Myfile[i+22]); inc(i); end;
   end
    else
   begin  // e (    :-) )
   seek(F,0); //    
   i:=0;
   while not eof(f) do
    begin read(F,b); Myfile[i]:=b; inc(i); end;
   myfilelength:=i-1;   {warm_start();}
//   posBas:=get_var(BasicProgBegin);
   i:=0;  while (i<myfilelength-16) do
    begin do_write(posBas+i,Myfile[i+16]); inc(i); end;
    //  RUN
    MainForm.SetFocus;
    i8080_do_opcodes(opcodes_to_run);
     end;
  end;
  if s='LVOV/DUMP' then //  SAV    
   begin
   seek(F,0); //    
   i:=0; while not eof(f) do begin read(F,b); Myfile[i]:=b; inc(i);end;
   i:=0; closeFile(F);
   while (i<$10000) do
   begin{ memory[i]:=Myfile[17+i];} Wmemory_A:=i; Wmemory_B:=Myfile[17+i]; Wmemory;inc(i);end;
   i:=0;  while (i<$4000) do begin
   Wvideo_a:=i;Wvideo_b:=Myfile[17+$10000+i];Wvideo; inc(i); end;
   i:=0;  while (i<$100) do begin

   Wports_a:=i;Wports_b:=Myfile[17+$10000+$4000+i]; Wports;
   inc(i);

   end;
   rgB:=Myfile[17+$10000+$4000+$100];   rgH:=Myfile[17+$10000+$4000+$100+4];
   rgC:=Myfile[17+$10000+$4000+$100+1];   rgL:=Myfile[17+$10000+$4000+$100+5];
   rgD:=Myfile[17+$10000+$4000+$100+2];   rgA:=Myfile[17+$10000+$4000+$100+6];
   rgE:=Myfile[17+$10000+$4000+$100+3];   rgF:=Myfile[17+$10000+$4000+$100+7];
   rgSP:=Myfile[17+$10000+$4000+$100+9]*256+Myfile[17+$10000+$4000+$100+8];
   rgPC:=Myfile[17+$10000+$4000+$100+11]*256+Myfile[17+$10000+$4000+$100+10];
   fillcharVideoDirty;   draw_screen;
   end;
 {$R-}
end;

procedure TMainForm.do_pause();
begin
	pause := not pause;
end;


procedure TMainForm.i8080_do_opcodes(nb_cycles : Cardinal);  //  
var tmp3, tmp2, tmp1, opcode : integer;
var { } r_A,r_B,r_C,r_D,r_E,r_H,r_L,r_F,r_PC,r_SP : integer;
clock:Cardinal;
{ } f_S, f_Z, f_5, f_A, f_3,f_P,f_1,f_C : Integer;
procedure m01m;begin tmp2:=tmp2+1 end;
procedure m02m;begin r_PC:=r_PC+3; end;
procedure m04m;Begin r_A:=(tmp2 and $FF); end;
procedure m06m;Begin r_A:=tmp2; end;
procedure m07m;Begin Rflags_a:=tmp2;Rflags; r_F:=(Rflags_result or (r_F and f_C)); end;
procedure m08m;Begin Rflags_a:=(tmp2 and $FF);Rflags; r_F:=Rflags_result; end;
procedure m09m;begin Rflags_a:=(tmp2);Rflags; r_F:=Rflags_result; end;
procedure m10m;begin Rflags_a:=(0);Rflags; r_F:=Rflags_result; end;
procedure m11m;begin Rflags_a:=(r_A);Rflags; r_F:=(Rflags_result or (r_F and f_A)); end;
procedure m12m;begin r_F:=(r_F or f_A); end;
procedure m13m;begin r_F:=(r_F or f_C); end;
procedure m14m;begin r_PC:=r_PC+1; end;
procedure m15m;begin r_PC:=r_PC+2; end;
procedure m16m;begin clock:=clock+4; end;
procedure m17m;begin clock:=clock+7; end;
procedure m18m;begin clock:=clock+5; end;
procedure m19m;begin clock:=clock+10; end;
procedure m20m;begin clock:=clock+11; end;
procedure m21m;begin clock:=clock+13; end;
procedure m22m;begin clock:=clock+16; end;
procedure m23m;begin clock:=clock+17; end;
procedure m24m;begin if ((r_F and f_C)<>0) then m01m else tmp2:=tmp2+0;end;
procedure m25m;begin m18m; m14m;end;
procedure m26m;begin m11m; m16m; m14m;end;
procedure m27m;begin m16m; m14m; end;
Function m28m:Cardinal; begin Result:=do_read(r_PC+2) end;
Function m29m:Cardinal; begin Result:=do_read(r_PC+1); end;
Function m30m:Cardinal; begin Result:=do_read2(r_L,r_H); end;
procedure m03m;begin m19m; m02m; end;
procedure m31m;begin m17m; m14m; end;
procedure m32m;begin if (tmp2>$FF) then begin m13m; end; end;
procedure m33m;begin m17m; m15m; end;
procedure m34m;begin m19m; m14m; end;
procedure m05m;Begin m32m; m04m; m27m; end;
procedure m35m;Begin m06m; m27m; end;
procedure m36m(a:Integer);Begin if (((tmp2 xor r_A xor a) and $10)<>0) then begin m12m; end; end;
procedure m37m(a:Integer); begin if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0; tmp2:=(r_A-a-tmp3) and $FF;end;
Function m38m:Cardinal; begin Result:=m30m; m31m; end;
Function m39m:Cardinal; begin Result:=m29m; m33m; end;
procedure m40m(a:Integer); begin tmp2:=(r_A-a) and $FF; m09m; if (r_A<a) then begin m13m; end; m36m(a); m35m; end;
procedure m41m(a:Integer); begin m37m(a); m09m; if (r_A<(a+tmp3)) then begin m13m; end;
m36m(a); m35m; end;
procedure m42m(a:Integer); begin if (((tmp2 xor a) and $10)<>0) then begin m12m; end; end;
procedure m43m(a:Integer); begin m07m; m42m(a); end;
procedure m44m(a:Integer); begin do_write2(r_L,r_H,a); end;
Function m46m:Cardinal; begin m46m:=m29m+(m28m shl 8); end;
procedure m45m; begin r_PC:=m46m; end;
procedure m47m; begin tmp1:=m29m; end;
procedure m48m; begin tmp1:=m46m; end;
procedure m49m; begin r_PC:=do_read(r_SP);end;
procedure m50m; begin r_SP:=(r_SP-2) and $FFFF;end;
procedure m51m; begin r_PC:=tmp1; m23m; end;
procedure m52m; begin m48m; m50m; m02m; end;
Function m53m:Boolean;Begin if ((r_F and f_S)<>0) then Result:=True else Result:=False; end;
Function m54m:Boolean;Begin if ((r_F and f_S)=0) then Result:=True else Result:=False; end;
Function m55m:Cardinal; begin m55m:=(r_PC shr 8) and $FF; end;
procedure m56m; begin do_write(r_SP,r_PC and $FF); end;
Function m57m:Boolean;Begin if ((r_F and f_C)<>0) then Result:=True else Result:=False; end;
Function m58m:Boolean;Begin if ((r_F and f_P)=0) then Result:=True else Result:=False; end;
Function m59m:Boolean;Begin if ((r_F and f_C)=0) then Result:=True else Result:=False; end;
Function m60m:Boolean;Begin if ((r_F and f_Z)=0) then Result:=True else Result:=False; end;
procedure m61m(a:Integer); begin r_A:=r_A and a; end;
procedure m62m(a:Integer); begin if (r_A<a) then begin m13m; end; m36m(a); m27m; end;
procedure m63m(a:Integer); begin tmp2:=(r_A-a) and $FF; m09m; m62m(a);end;
procedure m64m(a:Integer); begin r_A:=(r_A or a);end;
procedure m65m; begin r_F:=r_F or f_C; end;
procedure m66m; begin r_SP:=(r_SP+2) and $FFFF;end;
procedure m67m(a:Integer); begin r_A:=(r_A xor a);end;
procedure m68m; begin m52m; m56m; do_write(r_SP+1,m55m); m51m; end;
procedure m69m; begin r_F:=(r_F and (not f_C)); end;
procedure m70m(a:Integer); begin tmp2:=r_A+a; m08m; m36m(a); m05m; end;
procedure m73m(a:Integer); begin tmp2:=r_A+a; m24m; m08m; m36m(a);end;
procedure m71m(a:Integer); begin m73m(a); m05m; end;
procedure m74m; begin tmp1:=m30m; end;
procedure m75m; begin tmp2:=(r_A-tmp1) and $FF; end;
procedure m76m; begin if (r_A<tmp1) then begin m65m; end; end;
procedure m77m; begin m45m; m19m; end;
procedure m78m; begin m20m; m02m; end;
Function m79m:Boolean;Begin if ((r_F and f_P)<>0) then Result:=True else Result:=False; end;
procedure m80m; begin r_PC:=r_PC+do_read(r_SP+1) shl 8; end;
//procedure m80m; begin r_PC:=r_PC+do_read(r_SP+1) shl 8; end;
procedure m82m; begin m49m; m80m; m66m; m20m; end;
//procedure m82m; begin m49m; m80m; m66m; m20m; end;
procedure m84m(a:Integer); begin r_B:=a; m25m; end;
procedure m85m(a:Integer); begin tmp2:=(a and $FF); end;



begin
 {$R-}
r_A:=integer(rgA);r_b:=integer(rgB);r_c:=integer(rgC);r_d:=integer(rgD);
r_e:=integer(rgE);r_H:=integer(rgH);r_L:=integer(rgL);r_F:=integer(rgF);
r_PC:=integer(rgPC);r_SP:=integer(rgSP);

f_S:=integer(fS);f_Z:=integer(fZ);f_5:=integer(f5);f_A:=integer(fA);
f_3:=integer(f3);f_P:=integer(fP);f_1:=integer(f1);f_C:=integer(fC);

 clock:=0; tmp1:=0; tmp2:=0; tmp3:=0; // :-)
 while (clock < nb_cycles) do
 begin
 opcode:=do_read(r_PC);

case opcode of //    00 .. FF,   clock    ""  ...
 //   ,        !!!!
$00: begin m27m; end;
$F3: begin m27m; end;
$FB: begin m27m; end;
$01: begin r_B:=m28m; r_C:=m29m; m03m; end;
$02: begin do_write2(r_C,r_B,r_A); m31m; end;
$03: begin r_C:=r_C+1; if (r_C>$FF) then begin r_C:=0; r_B:=r_B+1;
 if (r_B>$FF) then begin r_B:=0; end; end; m25m; end;

$04: begin m85m(r_B+1); m43m(r_B); r_B:=tmp2; m25m; end;
$05: begin m85m(r_B-1); m43m(r_B); r_B:=tmp2; m25m; end;
$06: begin r_B:=m39m; end;

$07: begin r_A:=r_A SHL 1; if (r_A>$FF) then begin r_A:=r_A or 1; m65m; r_A:= r_A and $FF; end
 else begin m69m; end; m27m; end;

$08:m27m; $10: m27m; $18:m27m; $20:m27m; $28:m27m; $30:m27m;$38:m27m;

$09: begin r_L:=r_L+r_C; r_H:=r_H+r_B; if (r_L>$FF) then
 begin inc(r_H); r_L:=(r_L and $FF); end;
 if (r_H>$FF) then begin r_H:=(r_H and $FF); m13m;
 end else begin m69m; end; m34m; end;

$0A: begin r_A:=do_read2(r_C,r_B); m31m; end;

$0B: begin r_C:=r_C-1; if (r_C<0) then begin r_C:=$FF; r_B:=r_B-1;
 if (r_B<0) then begin r_B:=$FF; end; end; m25m; end;

$0C: begin m85m(r_C+1); m43m(r_C); r_C:=tmp2; m25m; end;
$0D: begin m85m(r_C-1); m43m(r_C); r_C:=tmp2; m25m; end;
$0E: begin r_C:=m39m; end;

$0F: begin tmp1:=(r_A and 1); r_A:=(r_A shr 1); if (tmp1<>0) then
 begin r_A:=(r_A or $80); m13m; end else
 begin r_F:=(r_F and ( not f_C)); end; m27m; end;

$11: begin r_D:=m28m; r_E:=m29m; m03m; end;
$12: begin do_write2(r_E,r_D,r_A); m31m; end;

$13: begin r_E:=r_E+1; if (r_E>$FF) then begin r_E:=0; r_D:=r_D+1;
 if (r_D>$FF) then begin r_D:=0; end; end; m25m; end;

$14: begin m85m(r_D+1); m43m(r_D); r_D:=tmp2; m25m; end;
$15: begin m85m(r_D-1); m43m(r_D); r_D:=tmp2; m25m; end;

$16: begin r_D:=m39m; end;

$17: begin r_A:=(r_A shl 1); if m57m then
 begin r_A:=(r_A or 1); end; if (r_A>$FF) then begin m13m;
 r_A:=(r_A and $FF); end else begin m69m; end; m27m; end;

$19: begin r_L:=(r_L + r_E); r_H:=(r_H + r_D); if (r_L>$FF) then
 begin inc(r_H); r_L:=(r_L and $FF); end;
 if (r_H>$FF) then begin r_H:=(r_H and $FF); m13m;
 end else begin r_F:=(r_F and not (f_C)); end; m34m; end;

$1A: begin r_A:=do_read2(r_E,r_D); m31m; end;

$1B: begin r_E:=r_E-1; if (r_E<0) then begin r_E:=$FF; r_D:=r_D-1;
 if (r_D<0) then begin r_D:=$FF; end; end; m25m; end;

$1C: begin m85m(r_E+1); m43m(r_E); r_E:=tmp2; m25m; end;
$1D: begin m85m(r_E-1); m43m(r_E); r_E:=tmp2; m25m; end;
$1E: begin r_E:=m39m; end;

$1F: begin tmp1:=(r_A and 1); r_A:=(r_A SHR 1); if m57m then
 begin r_A:=(r_A or $80); end; if (tmp1<>0) then begin m13m; end
 else begin r_F:=(r_F and not(f_C)); end; m27m; end;

$21: begin r_H:=m28m; r_L:=m29m; m03m; end;

$22: begin m48m; do_write(tmp1,r_L); do_write(tmp1+1,r_H); m22m; m02m; end;

$23: begin r_L:=r_L+1; if (r_L>$FF) then begin r_L:=0; r_H:=r_H+1;
 if (r_H>$FF) then begin r_H:=0; end; end; m25m; end;

$24: begin m85m(r_H+1); m43m(r_H); r_H:=tmp2; m25m; end;
$25: begin m85m(r_H-1); m43m(r_H); r_H:=tmp2; m25m; end;

$26: begin r_H:=m39m; end;

$27: begin tmp1:=0; if (((r_F and f_C)<>0) or (r_A>$99)) then
 begin tmp1:=(tmp1 or $60); end;
 if (((r_F and f_A)<>0) or ((r_A and $0F)>$09)) then begin tmp1:=(tmp1 or $06); end;
 tmp2:=r_A+tmp1; m08m; m36m(tmp1); m32m; m04m; m27m; end;

$29: begin r_L:=r_L + r_L; r_H:=r_H + r_H; if (r_L>$FF) then begin
 inc(r_H); r_L:=(r_L and $FF); end; if (r_H>$FF) then begin
 r_H:=(r_H and $FF); m13m; end else begin m69m; end; m34m; end;

$2A: begin m48m; r_L:=do_read(tmp1); r_H:=do_read(tmp1+1); m22m; m02m; end;

$2B: begin r_L:=r_L-1; if (r_L <0) then begin r_L:=$FF; r_H:=r_H-1;
 if (r_H<0) then begin r_H:=$FF; end; end; m18m; m14m; end;

$2C: begin m85m(r_L+1); m43m(r_L); r_L:=tmp2; m25m; end;
$2D: begin m85m(r_L-1); m43m(r_L); r_L:=tmp2; m25m; end;
$2E: begin r_L:=m39m; end;
$2F: begin r_A:=(r_A xor $FF); m27m; end;
$31: begin r_SP:=(m28m shl 8)+m29m; m03m; end;
$32: begin do_write2(m29m,m28m,r_A); m21m; m02m; end;
$33: begin if (r_SP=$FFFF) then begin r_SP:=0; end else begin inc(r_SP); end; m25m; end;
$34: begin m74m; m85m(tmp1+1); m43m(tmp1); m44m(tmp2); m34m; end;
$35: begin m74m; m85m(tmp1-1); m43m(tmp1); m44m(tmp2); m34m; end;
$36: begin m44m(m29m); m19m; m15m; end;
$37: begin m13m; m27m; end;


$39: begin r_L:=(r_L + (r_SP and $FF)); r_H:=(r_H + ((r_SP shr 8) and $FF));
 if (r_L>$FF) then begin inc(r_H); r_L:=(r_L and $FF); end;
 if (r_H>$FF) then begin r_H:=(r_H and $FF); m13m; end else begin m69m; end; m34m; end;

$3A: begin r_A:=do_read2(m29m,m28m); m21m; m02m; end;

$3B: begin if (r_SP<>0) then begin r_SP:=r_SP-1; end else begin r_SP:=$FFFF; end;
 m25m; end;
$3C: begin m85m(r_A+1); m43m(r_A); m06m; m25m; end;
$3D: begin m85m(r_A-1); m43m(r_A); m06m; m25m; end;
$3E: begin r_A:=m39m; end;
$3F: begin r_F:=r_F xor f_C; m27m; end;

$40:m25m;$52:m25m; $5B:m25m; $64:m25m; $6D:m25m; $7F:m25m;
//procedure m84m(a:Integer); begin r_B:=a; m25m; end;
$41: m84m(r_C); $42: m84m(r_D); $43: m84m(r_E); $44: m84m(r_H); $45: m84m(r_L);
$46: r_B:=m38m; $47: m84m(r_A);
$48: begin r_C:=r_B; m25m; end;
$49:m25m; 
$4A: begin r_C:=r_D; m25m; end;
$4B: begin r_C:=r_E; m25m; end;
$4C: begin r_C:=r_H; m25m; end;
$4D: begin r_C:=r_L; m25m; end;
$4E: begin r_C:=m38m; end;
$4F: begin r_C:=r_A; m25m; end;
$50: begin r_D:=r_B; m25m; end;
$51: begin r_D:=r_C; m25m; end;
$53: begin r_D:=r_E; m25m; end;
$54: begin r_D:=r_H; m25m; end;
$55: begin r_D:=r_L; m25m; end;
$56: begin r_D:=m38m; end;
$57: begin r_D:=r_A; m25m; end;
$58: begin r_E:=r_B; m25m; end;
$59: begin r_E:=r_C; m25m; end;
$5A: begin r_E:=r_D; m25m; end;
$5C: begin r_E:=r_H; m25m; end;
$5D: begin r_E:=r_L; m25m; end;
$5E: begin r_E:=m38m; end;
$5F: begin r_E:=r_A; m25m; end;
$60: begin r_H:=r_B; m25m; end;
$61: begin r_H:=r_C; m25m; end;
$62: begin r_H:=r_D; m25m; end;
$63: begin r_H:=r_E; m25m; end;
$65: begin r_H:=r_L; m25m; end;
$66: begin r_H:=m38m; end;
$67: begin r_H:=r_A; m25m; end;
$68: begin r_L:=r_B; m25m; end;
$69: begin r_L:=r_C; m25m; end;
$6A: begin r_L:=r_D; m25m; end;
$6B: begin r_L:=r_E; m25m; end;
$6C: begin r_L:=r_H; m25m; end;
$6E: begin r_L:=m38m; end;
$6F: begin r_L:=r_A; m25m; end;
$70: begin m44m(r_B); m31m; end;
$71: begin m44m(r_C); m31m; end;
$72: begin m44m(r_D); m31m; end;
$73: begin m44m(r_E); m31m; end;
$74: begin m44m(r_H); m31m; end;
$75: begin m44m(r_L); m31m; end;
$76: begin m27m; end;
$77: begin m44m(r_A); m31m; end;
$78: begin r_A:=r_B; m25m; end;
$79: begin r_A:=r_C; m25m; end;
$7A: begin r_A:=r_D; m25m; end;
$7B: begin r_A:=r_E; m25m; end;
$7C: begin r_A:=r_H; m25m; end;
$7D: begin r_A:=r_L; m25m; end;
$7E: begin r_A:=m38m; end;
$80: begin tmp2:=r_A+r_B; m08m; m36m(r_B); m32m; r_A:=(tmp2 and $FF); m27m; end;

$81:m70m(r_C);$82:m70m(r_D);$83:m70m(r_E);$84:m70m(r_H);$85:m70m(r_L);

$86: begin m74m; tmp2:=r_A+tmp1; m08m; m36m(tmp1); m32m; m04m; m31m; end;
$87: m70m(r_A);
$88:m71m(r_B); $89:m71m(r_C); $8A:m71m(r_D);$8B:m71m(r_E);
$8C: begin m73m(r_H); if (tmp2>$FF) then begin m65m; end; m04m; m27m; end;
$8D:m71m(r_L);
$8E: begin m74m; m73m(tmp1); m32m; m04m; m31m; end;
$8F:m71m(r_A); $90:m40m(r_B); $91:m40m(r_C);$92:m40m(r_D); $93:m40m(r_E); $94:m40m(r_H);
$95: begin m85m(r_A-r_L); m09m; if (r_A<r_L) then begin m65m; end; m36m(r_L); m35m; end;
$96: begin m74m; m75m; m09m; if (r_A<tmp1) then begin m13m; end; m36m(tmp1); m06m; m31m; end;
$97: begin m10m; r_A:=0; m27m; end;
$98: m41m(r_B);$99: m41m(r_C);$9A: m41m(r_D);$9B: m41m(r_E);$9C: m41m(r_H);$9D: m41m(r_L);

$9E: begin m74m; if m57m then tmp3:=1 else tmp3:=0;
 m85m(r_A-tmp1-tmp3); m09m; if (r_A<tmp1+tmp3) then begin m13m; end;
 m36m(tmp1); m06m; m31m; end;

$9F: begin if m57m then tmp2:=$FF else tmp2:=0; m09m; if (tmp2<>0) then
 begin r_F:=r_F or (f_A or f_C); end; m35m; end;

$A0: begin m61m(r_B); m26m; end;
$A1: begin m61m(r_C); m26m; end;
$A2: begin m61m(r_D); m26m; end;
$A3: begin m61m(r_E); m26m; end;
$A4: begin m61m(r_H); m26m; end;
$A5: begin m61m(r_L); m26m; end;
$A6: begin m74m; m61m(tmp1); m11m; m31m; end;
$A7: begin m61m(r_A); m26m; end;

$A8: begin m67m(r_B); m26m; end;
$A9: begin m67m(r_C); m26m; end;
$AA: begin m67m(r_D); m26m; end;
$AB: begin m67m(r_E); m26m; end;
$AC: begin m67m(r_H); m26m; end;
$AD: begin m67m(r_L); m26m; end;
$AE: begin m74m; m67m(tmp1); m11m; m17m; m14m; end; $AF: begin r_A:=0; m26m; end;

$B0: begin m64m(r_B); m26m; end;
$B1: begin m64m(r_C); m26m; end;
$B2: begin m64m(r_D); m26m; end;
$B3: begin m64m(r_E); m26m; end;
$B4: begin m64m(r_H); m26m; end;
$B5: begin m64m(r_L); m26m; end;
$B6: begin m74m; m64m(tmp1); m11m; m31m; end;
$B7: begin m64m(r_A); m26m; end;

$B8:m63m(r_b); $B9:m63m(r_c); $BA:m63m(r_d); $BB:m63m(r_e); $BC:m63m(r_h);$BD:m63m(r_l);

$BE: begin m74m; m75m; m09m; if (r_A<tmp1) then begin m13m; end; m36m(tmp1); m31m; end;
$BF: begin m10m; m27m; end;
$C0: begin if ((r_F and f_Z)<>0) then begin m25m; end else begin m82m; end; end;
$C1: begin r_C:=do_read(r_SP); r_B:=do_read(r_SP+1); m66m; m34m; end;

$C2: begin if ((r_F and f_Z)<>0) then begin m03m; end
 else begin r_PC:=m29m+((m28m shl 8)); m19m; end; end;

$C3: begin r_PC:=m29m+((m28m shl 8)); m19m; end;
$C4: begin if ((r_F and f_Z)<>0) then begin m78m; end else
 begin tmp1:=m29m+((m28m shl 8)); m50m; m02m; m56m; do_write(r_SP+1,m55m); m51m; end; end;

$C5: begin m50m; do_write(r_SP,r_C); do_write(r_SP+1,r_B); m20m; m14m; end;

$C6: begin m47m; tmp2:=r_A+tmp1; m08m; m36m(tmp1);
if (tmp2>$FF) then begin m65m; end; m04m; m33m; end;

$C7: begin m50m; m14m; m56m; do_write(r_SP+1,m55m); r_PC:=0*8; m20m; end;

$C8: begin if m60m then begin m25m; end else begin m82m; end; end;
$C9: begin m82m; end;
$CA: begin if m60m then begin m03m; end else begin m77m; end; end;
$CB: m77m;
$CC: begin if m60m then begin m78m; end else m68m; end;
$CD: m68m;
$CE: begin m47m; m73m(tmp1); if (tmp2>$FF) then begin m65m; end; m04m; m33m; end;
$CF: begin m50m; m14m; m56m; do_write(r_SP+1,m55m); r_PC:=1*8; m20m; end;
$D0: begin if m57m then begin m25m; end else begin m82m; end end;
$D1: begin r_E:=do_read(r_SP); r_D:=do_read(r_SP+1); m66m; m34m; end;
$D2: begin if m57m then begin m03m; end else begin m77m; end; end;
$D3: begin do_output(m29m,r_A); m19m; m15m; end;
$D4: begin if m57m then begin m78m; end else begin m68m; end; end;
$D5: begin m50m; do_write(r_SP,r_E); do_write(r_SP+1,r_D); m20m; m14m; end;
$D6: begin m47m; m75m; m09m; m76m; m36m(tmp1); m06m; m33m; end;
$D7: begin m50m; m14m; m56m; do_write(r_SP+1,m55m); r_PC:=2*8; m20m; end;
$D8: begin if m59m then begin m25m; end else begin m82m; end; end;
$D9: begin begin m82m; end; end;
$DA: begin if m59m then begin m03m; end else begin m77m; end; end;
$DB: begin r_A:=do_input(m29m); m19m; m15m; end;
$DC: begin if m59m then begin m78m; end else begin m68m; end; end;

$DD: m68m;$ED: m68m;$FD: m68m;

$DE: begin m47m; if m57m then tmp3:=1 else tmp3:=0;
 m85m(r_A-tmp1-tmp3); m09m; if (r_A<tmp1+tmp3) then begin
 m65m; end; m36m(tmp1); m06m; m33m; end;

$DF: begin m50m; m14m; m56m; do_write(r_SP+1,m55m); r_PC:=3*8; m20m; end;
$E0: begin if m79m then begin m25m; end else begin m82m; end ; end;
$E1: begin r_L:=do_read(r_SP); r_H:=do_read(r_SP+1); m66m; m34m; end;
$E2: begin if m79m then begin m03m; end else begin m77m; end; end;

$E3: begin tmp1:=do_read(r_SP); do_write(r_SP,r_L); r_L:=tmp1;
 tmp1:=do_read(r_SP+1); do_write(r_SP+1,r_H); r_H:=tmp1; clock:=clock+18; m14m; end;

$E4: begin if m79m then begin m78m; end else begin m68m; end; end;
$E5: begin m50m; do_write(r_SP,r_L); do_write(r_SP+1,r_H); m20m; m14m; end;
$E6: begin m61m(m29m); m11m; m33m; end;
$E7: begin m50m; m14m; m56m; do_write(r_SP+1,m55m); r_PC:=4*8; m20m; end;
$E8: begin if m58m then begin m25m; end else begin m82m; end; end;
$E9: begin r_PC:=(r_H shl 8)+r_L; m18m; end;
$EA: begin if m58m then begin m03m; end else begin m77m; end; end;
$EB: begin tmp1:=r_D; r_D:=r_H; r_H:=tmp1; tmp1:=r_E; r_E:=r_L; r_L:=tmp1; m16m; m14m; end;
$EC: begin if m58m then begin m78m; end else begin m68m; end; end;
$EE: begin r_A:= r_A xor m29m; m11m; m33m; end;
$EF: begin m50m; m14m; m56m; do_write(r_SP+1,m55m); r_PC:=5*8; m20m; end;
$F0: begin if m53m then begin m25m; end else begin m82m; end; end;
$F1: begin r_F:=do_read(r_SP); r_A:=do_read(r_SP+1); m66m; m34m; end;
$F2: begin if m53m then begin m03m; end else begin m77m; end; end;
$F4: begin if m53m then begin m78m; end else begin m68m; end; end;
$F5: begin m50m; do_write(r_SP,r_F); do_write(r_SP+1,r_A); m20m; m14m; end;
$F6: begin m64m(m29m); m11m; m33m; end;
$F7: begin m50m; m14m; m56m; do_write(r_SP+1,m55m); r_PC:=6*8; m20m; end;
$F8: begin if m54m then begin m25m; end else begin m82m; end; end;
$F9: begin r_SP:=(r_H shl 8)+r_L; m25m; end;
$FA: begin if m54m then begin m03m; end else begin m77m; end; end;
$FC: begin if m54m then begin m78m; end else begin m68m; end; end;
$FE: begin m47m; m75m; m09m; m76m; m36m(tmp1); m17m; m15m; end;
$FF: begin m50m; m14m; m56m; do_write(r_SP+1,m55m); r_PC:=7*8; m20m; end
 end;
end;

rgA:=Cardinal(r_A);rgB:=Cardinal(r_b);rgC:=Cardinal(r_c);rgD:=Cardinal(r_d);
rgE:=Cardinal(r_e);rgH:=Cardinal(r_H);rgL:=Cardinal(r_L);rgF:=Cardinal(r_F);
rgPC:=Cardinal(r_PC);rgSP:=Cardinal(r_SP);

fS:=Cardinal(f_S);fZ:=Cardinal(f_Z);f5:=Cardinal(f_5);fA:=Cardinal(f_A);
f3:=Cardinal(f_3);fP:=Cardinal(f_P);f1:=Cardinal(f_1);fC:=Cardinal(f_C);
{$R+}
end;



procedure TMainForm.draw_screen1;

Begin
 {$R-}
//if FullScreen1.Checked then //     
MainForm.Canvas.StretchDraw(rect(0,0,MainForm.Width-0,MainForm.Height-30), gamecanvas)
//else
//MainForm.Canvas.Draw(0,0,gamecanvas);
 {$R+}
end;



//function col_index(port : Cardinal; color : Cardinal): Cardinal; //      

var col_index_port,col_index_color,col_index_result:cardinal;
procedure TMainForm.col_index;
Var port,color,result_:Cardinal;
begin
 {$R-}
port:=col_index_port; color:=col_index_color;
 Result_:=LVColBlack;
 if ((port and $40)<>0) then Result_:= (Result_ xor LVColBlue);
 if ((port and $20)<>0) then Result_:= (Result_ xor LVColLime);
 if ((port and $10)<>0) then Result_:= (Result_ xor LVColRed);
// case color of
 if color = LVColBlack then
 begin
 if ((port and $08)=0) then
 begin Result_:= (Result_ xor LVColRed); end;
 if ((port and $04)=0) then
 begin Result_:= (Result_ xor LVColBlue); end;
 end else
 if color = LVColLime then begin Result_:= (Result_ xor LVColLime); end else
 if color = LVColRed then begin Result_:= (Result_ xor LVColRed);
 if ((port and $02)=0) then
 begin Result_:= (Result_ xor LVColLime); end; end else
 if color = LVColBlue then begin Result_:= (Result_ xor LVColBlue);
 if ((port and $01)=0) then
 begin Result_:= (Result_ xor LVColRed); end; end;

col_index_result:=result_;
 {$R+}
end;



var My_col_inp,My_col_result:Cardinal;

Procedure TMainForm.My_col2;
var inp,result:Cardinal;
begin
 {$R-}
inp:=My_col_inp;
if inp=0 then My_col_result:=LVColBlack else
if inp=1 then My_col_result:=LVColLime else
if inp=2 then My_col_result:=LVColBlue else
if inp=3 then My_col_result:=LVColRed else
 {$R+}
end;


var SupCol2_c1,SupCol2_b,SupCol2_x:Cardinal;

var SupCol2_Result:Cardinal;
Procedure TMainForm.SupCol2;
 Var c1,b,x,_Result:Cardinal;
 pix:Cardinal;
begin
 {$R-}
 c1:=SupCol2_c1; b:=SupCol2_b; x:=SupCol2_x; pix:=0;
 case x of
 1: begin
 if (b and 128)=128 then pix:=pix+1;
 if (b and 8)=8 then pix:=pix+2;
 end;
 2: begin
 if (b and 64)=64 then pix:=pix+1;
 if (b and 4)=4 then pix:=pix+2;
 end;
 3: begin
 if (b and 32)=32 then pix:=pix+1;
 if (b and 2)=2 then pix:=pix+2;
 end;
 4: begin
 if (b and 16)=16 then pix:=pix+1;
 if (b and 1)=1 then pix:=pix+2;
 end;
 end;
 col_index_port:=c1;
 My_Col_inp:=pix;My_Col2;
 col_index_color:=My_col_result;
 col_index;SupCol2_Result:=col_index_result;
 {$R+}
end;

var draw_screen2_i:Cardinal;

procedure TMainForm.draw_screen2; //  video   ()

var vertX,gorY : Cardinal;

begin

 vertX:= (draw_screen2_i mod 64)*4; gorY:=(draw_screen2_i div 64)*1;

 Rports_a:=$C1;Rports;

 SupCol2_c1:=Rports_result;Rvideo_a:=draw_screen2_i;Rvideo;

 SupCol2_b:=Rvideo_result;

 SupCol2_x:=1;SupCol2;
 gamecanvas.Canvas.Pixels[vertX,gorY]:= SupCol2_Result;
 SupCol2_x:=2;SupCol2;
 gamecanvas.Canvas.Pixels[vertX+1,gorY]:=SupCol2_Result;
 SupCol2_x:=3;SupCol2;
 gamecanvas.Canvas.Pixels[vertX+2,gorY]:=SupCol2_Result;
 SupCol2_x:=4;SupCol2;
 gamecanvas.Canvas.Pixels[vertX+3,gorY]:=SupCol2_Result;
end;

procedure TMainForm.draw_screen; //  video   ()

var i:Cardinal;

begin
{$R-}

for i:=0 to $3fff do begin

 Rvideo_a:=i;Rvideo;
 RVideoDirty_a:=i;RVideoDirty;
 if Rvideo_Result<>RVideoDirty_Result then //  ,    
 begin
 draw_screen2_i:=i; draw_screen2;
 Rvideo_a:=i;Rvideo;
 WVideoDirty_a:=i; WVideoDirty_b:=Rvideo_Result;WVideoDirty;
 end;
 end;
draw_screen1;
{$R+}
end;




procedure TMainForm.FirstPusk; // 
 begin
 //    
 gamecanvas:=tbitmap.Create;
 gamecanvas.Width:=256;
 gamecanvas.Height:=256;

 ResetComp; //   
 TimerMain.Enabled:=true; //   
end;

function TMainForm.readmask (keynum: word): word; //  
begin
result:= $72FF;
case keynum of
 8: begin result:= $23FF end; // BCK
 13: begin result:= $13FF end; // ENTER
	 16: begin result:= $70FF end; // SHIFT
 32: begin result:= $30FF end; // SPC

 37: begin result:= $FF32 end; // <-
 38: begin result:= $FF31 end; // UP
 39: begin result:= $FF30 end; // ->
 40: begin result:= $FF33 end; // DOWN

 48: begin result:= $06FF end; // 0
	 49: begin result:= $47FF end; // 1
	 50: begin result:= $46FF end; // 2
 	 51: begin result:= $45FF end; // 3
 	 52: begin result:= $44FF end; // 4
 	 53: begin result:= $43FF end; // 5
 	 54: begin result:= $00FF end; // 6
 	 55: begin result:= $01FF end; // 7
 	 56: begin result:= $02FF end; // 8
 	 57: begin result:= $07FF end; // 9

 	 65: begin result:= $64FF end; // A
 66: begin result:= $31FF end; // B
 67: begin result:= $57FF end; // C
 68: begin result:= $27FF end; // D
 69: begin result:= $54FF end; // E
 70: begin result:= $67FF end; // F
 71: begin result:= $10FF end; // G
 	 72: begin result:= $16FF end; // H
 	 73: begin result:= $75FF end; // I
 	 74: begin result:= $52FF end; // J
 75: begin result:= $55FF end; // K
 	 76: begin result:= $22FF end; // L
 	 77: begin result:= $76FF end; // M
 	 78: begin result:= $53FF end; // N
 	 79: begin result:= $21FF end; // O
 	 80: begin result:= $63FF end; // P
 	 81: begin result:= $71FF end; // Q
 82: begin result:= $20FF end; // R
 	 83: begin result:= $77FF end; // S
 	 84: begin result:= $74FF end; // T
 85: begin result:= $56FF end; // U
 	 86: begin result:= $26FF end; // V
 	 87: begin result:= $65FF end; // W
 	 88: begin result:= $73FF end; // X
 	 89: begin result:= $66FF end; // Y
 	 90: begin result:= $17FF end; // Z

 	 107: begin result:= $05FF end; // =/+ -> =/-
 	 109: begin result:= $05FF end; // -/_ -> =/-

 	 114: begin result:= $FF23 end; // F3
 	 115: begin result:= $FF22 end; // F4
 	 116: begin result:= $FF21 end; // F5

 	 36: begin result:= $FF20 end; // Home

 	 219: begin result:= $11FF end; // [
 	 221: begin result:= $12FF end; // ]
 	 190: begin result:= $24FF end; // .
 	 188: begin result:= $37FF end; // ,
 	 192: begin result:= $72FF end; //
end;

end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
if FPusk then //     
 begin
 FPusk:=false;
 FirstPusk;
 end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
DragAcceptFiles(MainForm.Handle, true); //     :)
FPusk:=true; //   
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
DragAcceptFiles(Handle, False);

end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word; // 
 Shift: TShiftState);
begin
 kbd(readmask(key),true); // 
// i8080_do_opcodes(opcodes_to_run);
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
 kbd(readmask(key),false); // 
end;

procedure TMainForm.TimerMainTimer(Sender: TObject); //  
var j,a: word;i: integer;s: string;
begin
//if (pause) then begin exit; end; //     :)
 i8080_do_opcodes(opcodes_to_run);
 draw_screen;
end;

procedure TMainForm.ResetComp;
begin
// rgB := 0; rgC := 0; rgD := 0; rgE := 0; rgH := 0; rgL := 0; rgA := 0; rgF := 0;
// rgPC := 0; rgSP := 0;
// pause := false;
// fS := (1 SHL 7); fZ :=( 1 SHL 6); f5 := (1 SHL 5); fA := (1 SHL 4); f3 := (1 SHL 3);
// fP := (1 SHL 2); f1 := (1 SHL 1); fC := (1 SHL 0);
 BasicStack := $AFC1; BasicHotEntry := $02FD; BasicProgBegin := $0243; BasicProgEnd := $0245;

fillcharVideoDirty;
//i8080_init;
// reset1();
// load_bios();
//rgPC:=$C000;
// i8080_do_opcodes(0);
TimerMain.Interval:=(1000 div FPS);
end;

procedure TMainForm.ResetCPU1Click(Sender: TObject);
begin
ResetComp;
end;

end.
