;//    
macro INT0x40 { int 0x40 }
;==============================
TableMy_col2INIT:
mov eax,[LVColBlack]
mov[TableMy_col2+(4*0)],eax
mov eax,[LVColLime]
mov[TableMy_col2+(4*1)],eax
mov eax,[LVColBlue]
mov[TableMy_col2+(4*2)],eax
mov eax,[LVColRed]
mov[TableMy_col2+(4*3)],eax
ret
;=================================
TableSupCol2INIT:
mov[TableSupCol2+(4*0)],SupCol2_ret
mov[TableSupCol2+(4*1)],SupCol2_m1
mov[TableSupCol2+(4*2)],SupCol2_m2
mov[TableSupCol2+(4*3)],SupCol2_m3
mov[TableSupCol2+(4*4)],SupCol2_m4
ret
;===============================
TableGraphicsModeINIT:
call TableMy_col2INIT
call TableSupCol2INIT
mov[TableGraphicsMode+(4*0)],PutPixel256_256
mov[TableGraphicsMode+(4*1)],PutPixel512_512
mov[TableGraphicsMode+(4*2)],PutPixel768_512

mov[TableDrawScreenPR+(4*0)],draw_screen256_256
mov[TableDrawScreenPR+(4*1)],draw_screen512_512
mov[TableDrawScreenPR+(4*2)],draw_screen768_512

ret

;     ImageData
;     ( ImageData ) 
   PutPixel_x: rd 1
   PutPixel_y rd 1
   PutPixel_color rd 1
;===========================================   
PutPixel256_256:
    mov eax, [PutPixel_x]
    mov ebx ,[PutPixel_y]
    mov ecx ,[PutPixel_color]
    imul ebx, 256 * 4
     mov [ImageData+eax*4+ebx], ecx
    ret
;===========================================
PutPixel512_512:
    mov eax, [PutPixel_x]
    mov ebx ,[PutPixel_y]
    mov ecx ,[PutPixel_color]
    imul eax,2
    imul ebx, 512 * 4
    imul ebx,2 ; 
    mov [ImageData+eax*4+ebx], ecx; 
    add eax,1
    mov [ImageData+eax*4+ebx], ecx; x+1
    ;============
    add ebx,512*4
    mov [ImageData+eax*4+ebx], ecx; 
    sub eax,1
    mov [ImageData+eax*4+ebx], ecx;
    ret
;===========================================
PutPixel768_512:
    mov eax, [PutPixel_x]
    mov ebx ,[PutPixel_y]
    mov ecx ,[PutPixel_color]
    imul eax,3
    imul ebx, 768 * 4
    imul ebx,2 ; 
    mov [ImageData+eax*4+ebx], ecx; 
    add eax,1
    mov [ImageData+eax*4+ebx], ecx; x+1
    add eax,1
    mov [ImageData+eax*4+ebx], ecx; x+2
    ;============
    add ebx,768*4
    mov [ImageData+eax*4+ebx], ecx; 
    sub eax,1
    mov [ImageData+eax*4+ebx], ecx;
    sub eax,1
    mov [ImageData+eax*4+ebx], ecx;
    ret
;===========================================

;   ImageData  ;   - 
draw_screen256_256:;DrawImageData:
    mov eax, 65
    mov ebx, ImageData
    mov ecx, 256 * 65536 + 256
    mov edx, 0;CanvasX * 65536 + CanvasY
    mov esi, 32
    xor ebp, ebp
    int 0x40
    ret
;=======================
draw_screen512_512:;DrawImageData:
    mov eax, 65
    mov ebx, ImageData
    mov ecx, 512 * 65536 + 512
    mov edx, 0;CanvasX * 65536 + CanvasY
    mov esi, 32
    xor ebp, ebp
    int 0x40
    ret
;=======================
draw_screen768_512:;DrawImageData:
    mov eax, 65
    mov ebx, ImageData
    mov ecx, 768 * 65536 + 512
    mov edx, 0;CanvasX * 65536 + CanvasY
    mov esi, 32
    xor ebp, ebp
    int 0x40
    ret
;=======================
PutPixel: ;    
  mov eax,[GraphicsMode]
 Call dword [eax*4+TableGraphicsMode] 
 ret
ret
;=======================
  col_index_port rd 1
  col_index_color rd 1
  col_index_result rd 1
col_index:
;917: port:=col_index_port; color:=col_index_color;
       mov eax,[col_index_port]
     mov ecx,[col_index_color]
;918: Result_:=LVColBlack;
     mov edx,[LVColBlack]
;919: if ((port and $40)<>0) then Result_:= (Result_ xor LVColBlue);
             test al,$40
             jz col_index_m1
       xor edx,[LVColBlue]           
;920: if ((port and $20)<>0) then Result_:= (Result_ xor LVColLime);
col_index_m1: test al,$20
             jz col_index_m2
     xor edx,[LVColLime]
;921: if ((port and $10)<>0) then Result_:= (Result_ xor LVColRed);
col_index_m2: test al,$10
             jz col_index_m3
     xor edx,[LVColRed]
;923: if color = LVColBlack then
col_index_m3:   cmp ecx,[LVColBlack]
             jnz col_index_m4
;925: if ((port and $08)=0) then
             test al,$08
             jnz col_index_m5
;926: begin Result_:= (Result_ xor LVColRed); end;
     xor edx,[LVColRed]
;927: if ((port and $04)=0) then
col_index_m5: test al,$04
             jnz col_index_ret
;928: begin Result_:= (Result_ xor LVColBlue); end;
     xor edx,[LVColBlue]
             jmp col_index_ret
;930: if color = LVColLime then begin Result_:= (Result_ xor LVColLime); end else
col_index_m4:   cmp ecx,[LVColLime]
             jnz col_index_m7
     xor edx,[LVColLime]
             jmp col_index_ret
;931: if color = LVColRed then begin Result_:= (Result_ xor LVColRed);
col_index_m7:  cmp ecx,[LVColRed]
             jnz col_index_m8
     xor edx,[LVColRed]
;uMainDA.pas.932: if ((port and $02)=0) then
             test al,$02
             jnz col_index_ret
;uMainDA.pas.933: begin Result_:= (Result_ xor LVColLime); end; end else
     xor edx,[LVColLime]
           jmp col_index_ret
;934: if color = LVColBlue then begin Result_:= (Result_ xor LVColBlue);
col_index_m8: cmp ecx,[LVColBlue]
              jnz col_index_ret
     xor edx,[LVColBlue]
;935: if ((port and $01)=0) then
             test al,$01
             jnz col_index_ret
;936: begin Result_:= (Result_ xor LVColRed); end; end;
     xor edx,[LVColRed]
;938: col_index_result:=result_;
col_index_ret:     mov [col_index_result],edx
;;//uMainDA.pas.940: end;
               ret    
;======================================================
  SupCol2_c1 rd 1
  SupCol2_b rd 1
  SupCol2_x rd 1
  SupCol2_Result rd 1
SupCol2:
;//1026: begin
               push ebx
               push esi
;             mov ebx,eax
;//1028: c1:=SupCol2_c1; b:=SupCol2_b; x:=SupCol2_x; pix:=0;
     mov ecx,[SupCol2_c1]
     mov edx,[SupCol2_b]
     mov esi,[SupCol2_x]
             xor eax,eax
;//1029: case x of (esi)
   jmp dword [esi*4+TableSupCol2]
;//1031: if (b and 128)=128 then pix:=pix+1;
SupCol2_m1:   mov esi,edx
           and esi,$00000080
        cmp esi,$00000080
             jnz SupCol2_m5
               inc eax
;//1032: if (b and 8)=8 then pix:=pix+2;
SupCol2_m5:  and edx,$08
           cmp edx,$08
             jnz SupCol2_ret2
           add eax,$02
             jmp SupCol2_ret2
;//1035: if (b and 64)=64 then pix:=pix+1;
SupCol2_m2:  mov esi,edx
          and esi,$40
           cmp esi,$40
             jnz SupCol2_m6
               inc eax
;//1036: if (b and 4)=4 then pix:=pix+2;
SupCol2_m6: and edx,$04
           cmp edx,$04
             jnz SupCol2_ret2
           add eax,$02
             jmp SupCol2_ret2
;//1039: if (b and 32)=32 then pix:=pix+1;
SupCol2_m3:   mov esi,edx
           and esi,$20
           cmp esi,$20
             jnz SupCol2_m7
               inc eax
;//1040: if (b and 2)=2 then pix:=pix+2;
SupCol2_m7: and edx,$02
           cmp edx,$02
             jnz SupCol2_ret2
           add eax,$02
             jmp SupCol2_ret2
;//1043: if (b and 16)=16 then pix:=pix+1;
SupCol2_m4:  mov esi,edx
           and esi,$10
           cmp esi,$10
             jnz SupCol2_m8
              inc eax
;//1044: if (b and 1)=1 then pix:=pix+2;
SupCol2_m8:  and edx,$01
           cmp edx,$01
             jnz SupCol2_ret2
           add eax,$02
;//1047: col_index_port:=c1;
SupCol2_ret2:
     mov [col_index_port],ecx
;//1048: My_Col_inp:=pix;My_Col2;
;//1049: col_index_color:=My_col_result;
mov eax,[eax*4+TableMy_col2]; ;       call My_col2
       mov [col_index_color],eax
;//1050: col_index;SupCol2_Result:=col_index_result;
       call col_index
       mov eax,[col_index_result]
       mov [SupCol2_Result],eax
;//1052: end;
SupCol2_ret:  pop esi
               pop ebx
               ret 
;================

 draw_screen2_i:rd 1 ; //    
draw_screen2:; //  video   ()
;               push ebx
;               push esi
;               push edi
;               mov ebx,eax
;//1139: vertX:= (draw_screen2_i mod 64)*4; gorY:=(draw_screen2_i div 64)*1;
       mov eax,[draw_screen2_i]
             and eax,$3f
             mov esi,eax
           shl esi,$02
       mov eax,[draw_screen2_i]
           shr eax,$06
             mov edi,eax
;//1140: Rports_a:=$C1;Rports;
;//1141: SupCol2_c1:=Rports_result;Rvideo_a:=draw_screen2_i;Rvideo;
   xor edx,edx
   mov dl,[portsM+$c1]
   mov [SupCol2_c1],edx
;//1142: SupCol2_b:=Rvideo_result; SupCol2_x:=1;SupCol2;
       mov edx,[draw_screen2_i]
       xor ebx,ebx
       mov bl,[videoM+edx]

       mov [SupCol2_b],ebx
       mov [SupCol2_x],$00000001
             mov eax,ebx
       call SupCol2
;//1143: PutPixel_x:=vertX;PutPixel_y:=gorY;PutPixel_color:= SupCol2_Result;PutPixel;{PutPixe2;}
     mov [PutPixel_x],esi
     mov [PutPixel_y],edi
       mov eax,[SupCol2_Result]
       mov [PutPixel_color],eax
             mov eax,ebx
       call PutPixel
;///1145: SupCol2_x:=2;SupCol2;
 mov [SupCol2_x],$00000002
             mov eax,ebx
       call SupCol2
;//1146: PutPixel_x:=vertX+1;PutPixel_y:=gorY;PutPixel_color:= SupCol2_Result;PutPixel;
           lea eax,[esi+$01]
       mov [PutPixel_x],eax
       mov [PutPixel_y],edi
       mov eax,[SupCol2_Result]
       mov [PutPixel_color],eax
             mov eax,ebx
       call PutPixel
;//1148: SupCol2_x:=3;SupCol2;
       mov [SupCol2_x],$00000003
             mov eax,ebx
       call SupCol2
;//1149: PutPixel_x:=vertX+2;PutPixel_y:=gorY;PutPixel_color:= SupCol2_Result;PutPixel;
           lea eax,[esi+$02]
       mov [PutPixel_x],eax
     mov [PutPixel_y],edi
       mov eax,[SupCol2_Result]
       mov [PutPixel_color],eax
             mov eax,ebx
       call PutPixel
;//1151: SupCol2_x:=4;SupCol2;
 mov [SupCol2_x],$00000004
             mov eax,ebx
       call SupCol2
;//1152: PutPixel_x:=vertX+3;PutPixel_y:=gorY;PutPixel_color:= SupCol2_Result;PutPixel;
           add esi,$03
     mov [PutPixel_x],esi
     mov [PutPixel_y],edi
       mov eax,[SupCol2_Result]
       mov [PutPixel_color],eax
             mov eax,ebx
       call PutPixel
;//uMainDA.pas.1153: end;
;               pop edi
;               pop esi
;               pop ebx
               ret
;============================
    draw_screen01_i rd 1
draw_screen01: ;{draw_screen:}
             push ebx
;//1227: draw_screen2_i:=draw_screen01_i; draw_screen2; //      
       mov eax,[draw_screen01_i]
       mov [draw_screen2_i],eax
       call draw_screen2
;//1228: Rvideo_a:=draw_screen01_i;Rvideo;
       mov edx,[draw_screen01_i]
       xor ebx,ebx
       mov bl,[videoM+edx]
;//1229: WVideoDirty_a:=draw_screen01_i; WVideoDirty_b:=Rvideo_Result;WVideoDirty;
       mov eax,[draw_screen01_i]
mov [eax+VideoDirtyM],bl ;       call WVideoDirty
              pop ebx
               ret
;==============               
draw_screen:
;//1261: begin;///1263: for i:=0 to $3fff do begin
             xor ebx,ebx
;//1265: Rvideo_a:=i;Rvideo;
draw_screen_m2:
;//1266: RVideoDirty_a:=i;RVideoDirty;
   xor ecx,ecx
mov cl,[VideoDirtyM+ebx]
       xor eax,eax
       mov al,[videoM+ebx]
;//1267: if Rvideo_Result<>RVideoDirty_Result then //  ,    
     cmp eax,ecx;[RVideoDirty_result]
             jz draw_screen_m1
;//1269: draw_screen01_i:=i; draw_screen01;
     mov [draw_screen01_i],ebx
       call draw_screen01
;//1271: end;
draw_screen_m1: inc ebx
;//1263: for i:=0 to $3fff do begin
     cmp ebx,$00004000
             jnz draw_screen_m2
;//1272: draw_screen1; //    
   mov eax,[GraphicsMode]
 Call dword [eax*4+TableDrawScreenPR]
              ret
;=======================================