unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus,MMSystem,ShellAPI, ImgList, ComCtrls,
  ToolWin;

type
  TserviceThread = Class (TThread)
    public
    procedure Execute; override;
    End;
    
  TMainFormEmu = class(TForm)
    TimerMain: TTimer;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    FullScreen1: TMenuItem;
    N6: TMenuItem;
    N17: TMenuItem;
    OpenDialogLvt: TOpenDialog;
    ResetCPU1: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    Russian1: TMenuItem;
    English1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ImageList1: TImageList;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;


    procedure TimerMainTimer(Sender: TObject);
    procedure do_write(addr : word; bt : byte);
    procedure i8080_init;
    procedure i8080_reset(addr: word);
    procedure invalid_opcode (opcode: byte);
    procedure putSound(bt : byte);
    function  do_read(addr : integer): word;
    procedure do_write2(a_lo : word; a_hi : word; bt : byte);
    function  do_read2(a_lo : word; a_hi : word): word;
    function  compute_color_index(port : byte; color : tcolor): tcolor;
    procedure WriteVRAM(b:Byte;x,y: integer);
    procedure init_memory();
    function  do_input(port : byte): byte;
    function  signal_inv_opc: boolean;
    procedure do_output(port : byte; bt : byte);
    procedure kbd(mask : word; press : boolean);
    procedure reset1;
    procedure load_bios;
    function  get_var(var1: word): word;
    procedure set_var(var1, val: word);
    procedure warm_start();
    procedure do_pause();
    procedure playTone();
    procedure enableSound();
    procedure i8080_do_opcodes(nb_cycles : integer);
    procedure draw_screen();
    procedure FirstPusk;
    function  readmask (keynum: word): word;
    procedure N4Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure FullScreen1Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure N17Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure NewLoadFile(filenameDnD: string;start : boolean);
    procedure ResetComp;
    procedure ResetCPU1Click(Sender: TObject);
    function  GrayTV(RGBColor : TColor) : TColor;
    procedure N7Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PlayBuffer(Buffer: array of byte);
    procedure N13Click(Sender: TObject);
    procedure VRAMTest(c1,b:Byte);
    procedure CalculateColor;
    procedure Russian1Click(Sender: TObject);
    procedure English1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure WMDropFiles(var Msg: TMessage); message wm_DropFiles;
    { Public declarations }
  end;

var
  MainFormEmu: TMainFormEmu;

  ServiceThread: TServiceThread;
    r_A : INTEGER;   // 
    r_B : INTEGER;
    r_C : INTEGER;
    r_D : INTEGER;
    r_E : INTEGER;
    r_H : INTEGER;
    r_L : INTEGER;
    r_F : INTEGER;
    r_PC : integer;  //   
    r_SP : integer;

    clock : integer;

    flags: array [0..256] of  word;

    f_S : byte;  // 
    f_Z : byte;
    f_5 : byte;
    f_A : byte;
    f_3 : byte;
    f_P : byte;
    f_1 : byte;
    f_C : byte;

    opcode : byte; //    !!!

    halt_inv :byte;
    halt_opc :byte;
    halt_hlt :byte;
    halt_bpx :byte;
    halt_bpr :byte;
    halt_bpw :byte;
    halt_bpi :byte;
    halt_bpo :byte;

    FPusk: boolean; //  

    gamecanvas: tbitmap; //       

    memory: array [0..65535] of byte;  //    $FFFF
    video : array [0..16384] of byte;  //  
    VideoDirty : array [0..16384] of word; //   
    ports : array [0..256]   of byte;      // 
    bios  : array [0..65535] of byte;    //    ,      
    Myfile: array [0..90000] of byte; //    DUMP SAV 

    SuperColor: array[0..255, 0..255,1..4] of Tcolor; //     

    pause : boolean; //  
    FPS : integer;  // frames per second :-)

    speaker: array [0..2000] of word; //  
    speaked : word;
    soundData: array [0..2000] of BYTE;
    soundEnabled : boolean;
   { header : TWaveFormatEx;
    waveOut : hWaveOut;
    outHdr : TWaveHdr;
    pBuf : tHandle;
    pBuffer : pointer;}


    myfilelength: word; //   
    //_filePos : integer;

    r_Halted: boolean;

    kbd_base : array  [0..8] of byte;  //   
    kbd_ext : array  [0..4] of byte;

    BasicStack : word;    //    
    BasicHotEntry : word;
    BasicProgBegin : word;
    BasicProgEnd : word;

    opcodes_to_run : integer;

    curSnd : word;
    restClock : word;

const MyColor:array[0..3] of Tcolor=(clBlack,clLime,clBlue,clRed);

implementation

uses Unit2, Unit3;

{$R *.dfm}

procedure TMainFormEmu.WMDropFiles(var Msg: TMessage);   //      
var
FileName: array[0..256] of char;
begin
DragQueryFile(THandle(Msg.WParam), 0, FileName, SizeOf(Filename));
MainFormEmu.Caption:=FileName;
NewLoadFile(FileName,true);
DragFinish(THandle(Msg.WParam));
end;

procedure TMainFormEmu.do_write(addr : word; bt : byte); //     :-)
begin
  addr:=(addr and $FFFF);
  if (addr>=$C000) then
  begin
    exit;
  end;
  if ((ports[$C2] and 2)<>0) then
  begin
    memory[addr]:=bt;
  end
  else
     if (addr<$4000) then
       begin
         exit;
       end
       else
         if (addr<$8000) then
           begin
              video[addr-$4000]:=bt;
             // memory[addr]:=bt; //        
           end
           else
           begin
               memory[addr]:=bt;
           end;
end;



procedure TMainFormEmu.i8080_init;
var
  j,i : word;
begin
  i:=0;
  while (i<256) do
  begin
    flags[i]:=f_1 or f_P;
    j:=0;
    while (j<8) do
    begin
       if ((i and (1 SHL j))<>0) then
             begin
                flags[i]:=(flags[i] xor f_P);
             end;
      inc(j);
    end;
       if ((i and $80)<>0) then
             begin
               flags[i]:=(flags[i] or f_S);
             end;
       if (i=0) then
             begin
               flags[i]:=(flags[i] or f_Z);
             end;
    inc(i);
  end;
end;

procedure TMainFormEmu.i8080_reset(addr: word);
begin
  r_A:=0;
  r_F:=0;
  r_B:=0;
  r_C:=0;
  r_D:=0;
  r_E:=0;
  r_H:=0;
  r_L:=0;
  r_SP:=0;
  r_Halted:=false;
  clock:=0;
  r_PC:=addr;
end;

procedure TMainFormEmu.invalid_opcode (opcode: byte); //     !!!???
begin
  ShowMessage('      '+inttostr(opcode)+'  '+inttostr(r_PC));
  inc(r_PC);
  r_PC:=r_PC and $ffff;
end;

procedure TMainFormEmu.N10Click(Sender: TObject);
begin
KeyboardForm.Show;
end;

procedure TMainFormEmu.N11Click(Sender: TObject);
begin
n11.Checked:=not n11.Checked;
if n11.Checked then ToolButton3.ImageIndex:=8 else ToolButton3.ImageIndex:=7;
pause:=n11.Checked;
end;

procedure TMainFormEmu.N13Click(Sender: TObject);
begin
N13.Checked:= not  N13.Checked;
end;

procedure TMainFormEmu.N17Click(Sender: TObject);
begin
ShowMessage(' 0.5');
end;


function TMainFormEmu.do_read(addr : integer): word; //    
begin
  addr:=(addr and $FFFF);
   if ((ports[$C2] and 2)<>0) then
  begin
    result := memory[addr];
  end
  else
  if (addr>$7FFF) then
  begin
    result := memory[addr];
  end
  else if (addr<$4000) then
  begin
    result := 0;
  end
  else begin
    result := video[addr-$4000];
  end;
end;

procedure TMainFormEmu.do_write2(a_lo : word; a_hi : word; bt : byte);  // 
begin
  do_write(a_lo+(a_hi SHL 8),bt);
end;

function TMainFormEmu.do_read2(a_lo : word; a_hi : word): word;
begin
  result := do_read(a_lo+(a_hi SHL 8));
end;

procedure TMainFormEmu.init_memory();    //    
var
  j , i : integer;
begin
  i:=$0000;
  while (i<$10000) do
  begin
    memory[i]:=0;
    inc(i);
  end;
  i:=$0000;
  while (i<$4000) do begin
    video[i]:=0;
    inc(i);
  end;
  i:=$0000;
  while (i<$100) do begin
    ports[i]:=0;
    inc(i);
  end;
  i:=0;
  while (i<8) do begin
    kbd_base[i]:=0;
    inc(i);
  end;
  i:=0;
  while (i<4) do begin
    kbd_ext[i]:=0;
    inc(i);
  end;
  i:=0;
  while (i<256) do begin
    flags[i]:=(f_1 or f_P);
    j:=0;
    while (j<8) do begin
      if ((i and (1 shl j))<>0) then
      begin
        flags[i]:= (flags[i] xor f_P);
      end;
      inc(j);
    end;
    if ((i and $80)<>0) then
    begin
      flags[i]:= (flags[i] or f_S);
    end;

    if (i=0) then
    begin
      flags[i]:=(flags[i] or f_Z);
    end;
    inc(i);
  end;
end;


function TMainFormEmu.do_input(port : byte): byte;  //     in
var
  i,r : integer;
  nD2 ,nD0 : byte;
begin
  nD2:=0;
  nD0:=0;
  port:=$C0+(port and $13);
  case port of
  $C2:     begin result := ports[$C2]; end;
  $D1:     begin
             nD0:=not ports[$D0];
             r:=0;
             i:=0;
             while (i<8) do
             begin
              if ((nD0 and (1 SHL i))<>0) then
                 begin
                    r:=(r or kbd_base[i]);
                 end;
              inc(i);
             end;
             result :=  ((not r) and $FF);
           end;
   $D2:    begin
             nD2:= not ports[$D2];
             r:=0;
             i:=0;
             while (i<4) do
              begin
               if ((nD2 and (1 SHL i))<>0) then
                  begin
                   r:=(r or kbd_ext[i]);
                  end;
               inc(i);
              end;
              result := not ((r SHL 4) or (nD2 and $0F)) and $FF;
            end
     else
        begin
           result := $FF;
        end;
end;
end;

procedure TMainFormEmu.do_output(port : byte; bt : byte); // out
begin
  port:=$C0+(port and $13);
  case port of
  $c1:  begin //   
          fillchar(VideoDirty,sizeof(VideoDirty),257); //  
        end;
  $c2:  begin
          putSound(bt);  //    
        end;
  end;
  ports[port]:=bt;
end ;

function TMainFormEmu.signal_inv_opc: boolean;
  begin
      result :=false;
  end;

procedure TMainFormEmu.kbd(mask : word; press : boolean); //      
var
  brow : byte;
  erow : byte;
  bcol : byte;
  ecol : byte;
begin
  bcol:=(mask SHR 12) and $0F;
  brow:=(mask SHR 8) and $0F;
  ecol:=(mask SHR 4) and $0F;
  erow:=(mask SHR 0) and $0F;
  
  if ((brow<8) and (bcol<8)) then
  begin
   if (press) then
    begin
      kbd_base[bcol]:=(kbd_base[bcol] or (1 SHL brow));
    end else begin
      kbd_base[bcol]:= (kbd_base[bcol] and (not(1 SHL brow)));
    end;
  end;

  if ((erow<8) and (ecol<4)) then
  begin
    if (press) then
    begin
      kbd_ext[ecol]:= (kbd_ext[ecol]or (1 SHL erow));
    end else begin
      kbd_ext[ecol]:= (kbd_ext[ecol] and (not(1 SHL erow)));
    end;
  end;
end;

procedure TMainFormEmu.reset1;    //   :)
var
  i : word;
begin
  i:=0;
  while (i<256) do begin
    ports[i]:=$FF;
    inc(i);
  end;
  i8080_init;
end;

procedure TMainFormEmu.load_bios;    //    
var
i: word;
b: byte;
f: file of byte;
begin
  i:=0;
  AssignFile(F,ExtractFilePath(Application.ExeName)+'\bios.dat');
  Reset(F);                   //     :)
  while not eof(f) do
   begin
    read(F,b);
    bios[i]:=b; //    ,   
    inc(i);
   end;
  closeFile(F);
  i:=0;
  while (i<$4000) do begin
    memory[$C000+i]:=bios[22+i];
    inc(i);
  end;
end;


procedure TMainFormEmu.N2Click(Sender: TObject);
begin
  OpenDialogLvt.InitialDir:=ExtractFilePath(Application.ExeName);
  if OpenDialogLvt.Execute then NewLoadFile(OpenDialogLvt.FileName,true);
end;

procedure TMainFormEmu.N4Click(Sender: TObject);
begin
gamecanvas.Free;
close;
end;

procedure TMainFormEmu.N6Click(Sender: TObject); //      
const
//hexdigit = '0123456789ABCDEFabcdef';
hexdigit: set of Char = ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','a','b','c','d','e','f',#13];
var
j,a: word;
i: integer;
s: string;
begin
if not DebuggerForm.Visible then
begin
 i:=0;
 j:=0;
 a:=0;
 s:='';
 while (i<$10000) do
     begin
      j:=j+1;
      if j>15 then
      begin
        DebuggerForm.StringGrid1.Cells[j,a+1]:=inttohex(memory[i],2);
        if (memory[i]>31) and (memory[i]<128) then s:=s+chr(memory[i]) else s:= s+'.';
        DebuggerForm.StringGrid1.Cells[j+1,a+1]:=s;
        j:=0;
        a:=a+1;
        s:='';
      end
      else
        begin
        DebuggerForm.StringGrid1.Cells[j,a+1]:=inttohex(memory[i],2);
        if (memory[i]>31) and (memory[i]<128) then s:=s+chr(memory[i]) else s:=s+'.';
       // s:=s+chr(memory[i]);
        end;
      inc(i);
     end;
DebuggerForm.AssFromTo(r_PC,r_PC+100);
DebuggerForm.Show;
end
else
DebuggerForm.close;
end;

procedure TMainFormEmu.N7Click(Sender: TObject);   //   
begin
N7.Checked:= not N7.Checked;
if N7.Checked then
     ToolButton7.ImageIndex:=13 else
     ToolButton7.ImageIndex:=12;

fillchar(VideoDirty,sizeof(VideoDirty),257);
draw_screen;
end;

function TMainFormEmu.get_var(var1: word): word;  //       
begin
    result:= memory[var1] + memory[var1+1]*256;
end;

procedure TMainFormEmu.set_var(var1, val: word);
begin
    memory[var1]:= (val and $FF);
    memory[var1+1]:= (round(val/256) and $FF);
end;

procedure TMainFormEmu.warm_start();  //  
begin
  ports[$C2]:=$FF;
  r_SP:=BasicStack;
  set_var(BasicStack,BasicHotEntry);
  r_PC:=BasicHotEntry;
end;

procedure TMainFormEmu.NewLoadFile(filenameDnD: string; start : boolean);  //    
var
f:file of byte;
b:Byte;
s: string;
posBas, Xend ,Xbeg ,Xrun : word;
i: integer;
begin
  s:='';
      AssignFile(f,filenameDnD); //    
      Reset(f);
      for I:= 0 to 8  do
        begin
           read(f,b);
           s:=s+chr(b);
           //Myfile[j]:=strtoint(s);
           // Size(f);
           //seek(f,100);
        end;
      if s='LVOV/2.0/' then //  LVT 
      begin
         read(f,b);
         if b=$D0 then      //  
         begin
           seek(F,0); //    
           i:=0;
           while not eof(f) do
              begin
                read(F,b);
                Myfile[i]:=b;
                inc(i);
              end;
           myfilelength:=i;
           closeFile(F);     // 
           Xbeg:=Myfile[16]+Myfile[17]*256;
           Xend:=Myfile[18]+Myfile[19]*256;
           Xrun:=Myfile[20]+Myfile[21]*256;
           if (start) then
              begin
                warm_start();
                r_PC:=Xrun;
              end;
           i:=0;
           while (i<=Xend-Xbeg) do
              begin
               do_write(Xbeg+i,Myfile[i+22]);
               inc(i);
              end;
         end
         else
         begin      // e (    :-) )
           seek(F,0); //    
           i:=0;
           while not eof(f) do
              begin
                read(F,b);
                Myfile[i]:=b;
                inc(i);
              end;
            myfilelength:=i-1;
            warm_start();
            posBas:=get_var(BasicProgBegin);
            i:=0;
            while (i<myfilelength-16) do
               begin
                do_write(posBas+i,Myfile[i+16]);
                inc(i);
               end;
              set_var(BasicProgEnd,posBas+myfilelength-16);
              //  RUN
              MainFormEmu.SetFocus;
              KeyboardForm.SendKeys('RUN');
              //i8080_do_opcodes(opcodes_to_run);
              KeyboardForm.SimulateKeystroke(VK_RETURN, 0);
              KeyboardForm.SimulateKeystroke(VK_RETURN, 0);
              //KeyboardForm.SendKeys('RUN');
         end;
       end;
      if s='LVOV/DUMP' then //  SAV    
         begin
           seek(F,0); //    
           i:=0;
           while not eof(f) do
              begin
                read(F,b);
                Myfile[i]:=b;
                inc(i);
              end;
           i:=0;
           closeFile(F);
           while (i<$10000) do
           begin
             memory[i]:=Myfile[17+i];
             inc(i);
           end;
           i:=0;
           while (i<$4000) do
           begin
            video[i]:=Myfile[17+$10000+i];
            inc(i);
           end;
           i:=0;
           while (i<$100) do
           begin
            ports[i]:=Myfile[17+$10000+$4000+i];
            inc(i);
           end;
           r_B:=Myfile[17+$10000+$4000+$100];
           r_H:=Myfile[17+$10000+$4000+$100+4];
           r_C:=Myfile[17+$10000+$4000+$100+1];
           r_L:=Myfile[17+$10000+$4000+$100+5];
           r_D:=Myfile[17+$10000+$4000+$100+2];
           r_A:=Myfile[17+$10000+$4000+$100+6];
           r_E:=Myfile[17+$10000+$4000+$100+3];
           r_F:=Myfile[17+$10000+$4000+$100+7];
           r_SP:=Myfile[17+$10000+$4000+$100+9]*256+Myfile[17+$10000+$4000+$100+8];
           r_PC:=Myfile[17+$10000+$4000+$100+11]*256+Myfile[17+$10000+$4000+$100+10];
           fillchar(VideoDirty,sizeof(VideoDirty),257); //  
           draw_screen;
         end;
end;

procedure  TMainFormEmu.do_pause();
begin
	pause := not pause;
end;

procedure TMainFormEmu.i8080_do_opcodes(nb_cycles : integer);    //  
var
  tmp  : integer;
  tmp3 : integer;
  tmp2 : integer;
  tmp1 : integer;
  opcode : integer;
begin
  clock:=0; tmp1:=0;  tmp2:=0;  tmp3:=0;  tmp:=0;     // :-) 
 while (clock < nb_cycles) do
 begin
  tmp:=r_PC;
  opcode:=do_read(r_PC);
 if (r_PC=56724) then       //    
                 begin
                    //Myfile:=addfile[fileCounter];
                    //inc(fileCounter);
                    ///_filePos:=0;
                     pause:=true;
                     N2Click(Self);
                     if OpenDialogLvt.Execute then NewLoadFile(OpenDialogLvt.FileName,true);
                     pause:=false;
                 end ;
                { else
                 begin
                     if (r_PC=58576) then
                          begin
                            opcode:=$C9;
                          end;
                     if (r_PC=58558) then
                          begin
                             if (_filePos<10) then
                                 begin
                                   r_A:=208;
                                   inc(_filePos);
                                 end
                                 else
                                 if (_filePos<16) then
                                       begin
                                          r_A:=do_read(48780+_filePos-10);
                                          inc(_filePos);
                                       end
                                       else
                                       if (_filePos<myfilelength) then
                                                  begin
                                                    r_A:=Myfile[_filePos];
                                                    inc(_filePos);
                                                  end
                                                  else
                                                  begin
                                                    r_A:=$FF;
                                                  end;
                            opcode:=$C9;
                            end;
                    if (r_PC=56778) then
                              begin
                                 if (_filePos<Myfilelength-1) then
                                        begin
                                           r_L:=Myfile[_filePos];
                                           inc(_filePos);
                                           r_H:=Myfile[_filePos];
                                           inc(_filePos);
                                        end
                                        else
                                        begin
                                          r_L:=$FF;
                                          r_H:=$FF;
                                        end;
                               opcode:=$C9;
                               end;
                     {if (gamover_point=r_PC) then
                         begin
                           makeRequest();
                         end;  }
               { end;  }

case opcode of         //    00 .. FF,   clock    ""  ...
                       //   ,         !!!!
  $00:
  begin
    clock:=clock+4;
    r_PC:=r_PC+1;
  end;
  $F3:
  begin
    clock:=clock+4;
    r_PC:=r_PC+1;
  end;
  $FB:
  begin
    clock:=clock+4;
    r_PC:=r_PC+1;
  end;

  $01:
  begin
    r_B:=do_read(r_PC+2);
    r_C:=do_read(r_PC+1);
    clock:=clock+10;
    r_PC:=r_PC+3;
  end;
  
  $02: 
  begin
    do_write2(r_C,r_B,r_A);
    clock:=clock+7;
    r_PC:=r_PC+1;
  end;
  
  $03: 
  begin
    r_C:=r_C+1;
    if (r_C>$FF) then
    begin
      r_C:=0;
      r_B:=r_B+1;
      if (r_B>$FF) then
      begin
        r_B:=0;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;

  $04:
  begin
    tmp2:=((r_B+1) and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));
    if (((tmp2 xor r_B) and $10)<>0) then
    begin
      r_F:=r_F or f_A;
    end;
    r_B:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $05: 
  begin
    tmp2:=((r_B-1) and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));

    if (((tmp2 xor r_B) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_B:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $06: 
  begin
    r_B:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $07: 
  begin
    r_A:=r_A SHL 1;
    if (r_A>$FF) then
    begin
      r_A:=r_A or 1;
      r_F:=r_F or f_C;
      r_A:= r_A and $FF;
    end
    else
    begin
      r_F:=(r_F and  (not f_C));
    end;
    clock:=clock+4;
    r_PC:=r_PC+1;
  end;
  $08:  begin     if (signal_inv_opc()) then
           begin
           end
           else
           begin
           clock:=clock+4;
           r_PC:=r_PC+1;
           end; end;
  $10:  begin     if (signal_inv_opc()) then
           begin
           end
           else
           begin
           clock:=clock+4;
           r_PC:=r_PC+1;
           end; end;
  $18:  begin     if (signal_inv_opc()) then
           begin
           end
           else
           begin
           clock:=clock+4;
           r_PC:=r_PC+1;
           end; end;
  $20:  begin     if (signal_inv_opc()) then
           begin
           end
           else
           begin
           clock:=clock+4;
           r_PC:=r_PC+1;
           end; end;
  $28:  begin     if (signal_inv_opc()) then
           begin
           end
           else
           begin
           clock:=clock+4;
           r_PC:=r_PC+1;
           end; end;
  $30:  begin     if (signal_inv_opc()) then
           begin
           end
           else
           begin
           clock:=clock+4;
           r_PC:=r_PC+1;
           end; end;
  $38:
  begin
    if (signal_inv_opc()) then
           begin
           end
           else
           begin
           clock:=clock+4;
           r_PC:=r_PC+1;
           end;
  end;
  
  $09: 
  begin
    r_L:=r_L+r_C;
    r_H:=r_H+r_B;
    if (r_L>$FF) then
    begin
      inc(r_H);
      r_L:=(r_L and $FF);
    end;
    if (r_H>$FF) then
    begin
      r_H:=(r_H and $FF);
      r_F:=(r_F or f_C);
    end
    else
    begin
      r_F:=(r_F and (not f_C));
    end;
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $0A: 
  begin
    r_A:=do_read2(r_C,r_B);
    clock:=clock+7;
    r_PC:=r_PC+1;
  end;

  $0B: 
  begin
    r_C:=r_C-1;
    if (r_C<0) then
    begin
      r_C:=$FF;
      r_B:=r_B-1;
      if (r_B<0) then
      begin
        r_B:=$FF;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $0C: 
  begin
    tmp2:=((r_C+1) and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));
    if (((tmp2 xor r_C) and $10)<>0) then
    begin
      r_F:=r_F or f_A;
    end;
    r_C:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;

  $0D:
  begin
    tmp2:=((r_C-1) and $FF);
    r_F:=flags[tmp2] or (r_F and f_C);

    if (((tmp2 xor r_C) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_C:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $0E: 
  begin
    r_C:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $0F: 
  begin
    tmp1:=(r_A and 1);
    r_A:=(r_A shr 1);
    if (tmp1<>0) then
    begin
      r_A:=(r_A or $80);
      r_F:=(r_F or f_C);
    end
    else
    begin
      r_F:=(r_F and ( not f_C));
    end;
    clock:=clock+4;
    r_PC:=r_PC+1;
  end;
  
  $11: 
  begin
    r_D:=do_read(r_PC+2);
    r_E:=do_read(r_PC+1);
    clock:=clock+10;
    r_PC:=r_PC+3;
  end;
  
  $12: 
  begin
    do_write2(r_E,r_D,r_A);
    clock:=clock+7;
    r_PC:=r_PC+1;
  end;
  
  $13: 
  begin
    r_E:=r_E+1;
    if (r_E>$FF) then
    begin
      r_E:=0;
      r_D:=r_D+1;
      if (r_D>$FF) then
      begin
        r_D:=0;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $14: 
  begin
    tmp2:=((r_D+1)and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));
    
    if (((tmp2 xor r_D) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_D:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $15: 
  begin
    tmp2:=((r_D-1)and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));
    
    if (((tmp2 xor r_D) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_D:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $16: 
  begin
    r_D:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $17: 
  begin
    r_A:=(r_A shl 1);

    if ((r_F and f_C)<>0) then 
    begin
      r_A:=(r_A or 1);
    end;
    
    if (r_A>$FF) then 
    begin
      r_F:=(r_F or f_C);
      r_A:=(r_A and $FF);
    end else begin
      r_F:=(r_F and (not f_C));
    end;
    clock:=clock+4;
    r_PC:=r_PC+1;
  end;
  
  $19: 
  begin
    r_L:=(r_L + r_E);
    r_H:=(r_H + r_D);
    
    if (r_L>$FF) then 
    begin
      inc(r_H);
      r_L:=(r_L and $FF);
    end;

    if (r_H>$FF) then 
    begin
      r_H:=(r_H and $FF);
      r_F:=(r_F or f_C);
    end
    else
    begin
      r_F:=(r_F and not (f_C));
    end;
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $1A: 
  begin
    r_A:=do_read2(r_E,r_D);
    clock:=clock+7;
    r_PC:=r_PC+1;
  end;
  
  $1B: 
  begin
    r_E:=r_E-1;
    if (r_E<0) then
    begin
      r_E:=$FF;
      r_D:=r_D-1;
      if (r_D<0) then
      begin
        r_D:=$FF;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $1C: 
  begin
    tmp2:=((r_E+1)and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));

    if (((tmp2 xor r_E) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_E:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $1D: 
  begin
    tmp2:=((r_E-1) and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));

    if (((tmp2 xor r_E) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_E:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $1E: 
  begin
    r_E:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $1F: 
  begin
    tmp1:=(r_A and 1);
    r_A:=(r_A SHR 1);
    
    if ((r_F and f_C)<>0) then
    begin
      r_A:=(r_A or $80);
    end;

    if (tmp1<>0) then
    begin
      r_F:=(r_F or f_C);
    end
    else
    begin
      r_F:=(r_F and not(f_C));
    end;
    clock:=clock+4;
    r_PC:=r_PC+1;
  end;

  $21:
  begin
    r_H:=do_read(r_PC+2);
    r_L:=do_read(r_PC+1);
    clock:=clock+10;
    r_PC:=r_PC+3;
  end;

  $22: 
  begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    do_write(tmp1,r_L);
    do_write(tmp1+1,r_H);
    clock:=clock+16;
    r_PC:=r_PC+3;
  end;
  
  $23: 
  begin
    r_L:=r_L+1;
    if (r_L>$FF) then
    begin
      r_L:=0;
      r_H:=r_H+1;
      if (r_H>$FF) then
      begin
        r_H:=0;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $24: 
  begin
    tmp2:=((r_H+1) and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));
    if (((tmp2 xor r_H) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_H:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $25: 
  begin
    tmp2:=((r_H-1) and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));
    if (((tmp2 xor r_H) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_H:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $26: 
  begin
    r_H:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $27: 
  begin
    tmp1:=0;
    if (((r_F and f_C)<>0) or  (r_A>$99)) then
    begin
      tmp1:=(tmp1 or $60);
    end;
    if (((r_F and f_A)<>0)    or  ((r_A and $0F)>$09)) then
    begin
      tmp1:=(tmp1 or $06);
    end;
    tmp2:=r_A+tmp1;
    r_F:=flags[tmp2 and $FF];
    if (((tmp2 xor r_A xor tmp1) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    if (tmp2>$FF) then
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
  end;
  
  $29: 
  begin
    r_L:=r_L + r_L;
    r_H:=r_H + r_H;
    
    if (r_L>$FF) then 
    begin
      inc(r_H);
      r_L:=(r_L and $FF);
    end;
    if (r_H>$FF) then
    begin
      r_H:=(r_H and $FF);
      r_F:=(r_F or f_C);
    end else begin
      r_F:=(r_F and (not f_C));
    end;
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $2A: 
  begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    r_L:=do_read(tmp1);
    r_H:=do_read(tmp1+1);
    clock:=clock+16;
    r_PC:=r_PC+3;
  end;
  
  $2B: 
  begin
    r_L:=r_L-1;
    if (r_L <0) then
    begin
      r_L:=$FF;
      r_H:=r_H-1;
      if (r_H<0) then
      begin
        r_H:=$FF;
      end;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $2C: 
  begin
    tmp2:=((r_L+1) and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));
    if (((tmp2 xor r_L) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_L:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $2D: 
  begin
    tmp2:=((r_L-1) and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));
    if (((tmp2 xor r_L) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_L:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $2E: 
  begin
    r_L:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $2F: 
  begin
    r_A:=(r_A xor $FF);
    clock:=clock+4;
    r_PC:=r_PC+1;
  end;
  
  $31: 
  begin
    r_SP:=(do_read(r_PC+2) shl 8)+do_read(r_PC+1);
    clock:=clock+10;
    r_PC:=r_PC+3;
  end;
  
  $32: 
  begin
    do_write2(do_read(r_PC+1),do_read(r_PC+2),r_A);
    clock:=clock+13;
    r_PC:=r_PC+3;
  end;
  
  $33: 
  begin
    if (r_SP=$FFFF) then
    begin
      r_SP:=0;
    end
    else
    begin
      inc(r_SP);
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $34: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=((tmp1+1)  and $FF);
    r_F:=(flags[tmp2] or (r_F  and f_C));
    if (((tmp2 xor tmp1) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    do_write2(r_L,r_H,tmp2);
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $35: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=((tmp1-1) and $FF);
    r_F:=flags[tmp2] or (r_F and f_C);
    if (((tmp2 xor tmp1) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    do_write2(r_L,r_H,tmp2);
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;

  $36:
  begin
    do_write2(r_L,r_H,do_read(r_PC+1));
    clock:=clock+10;
    r_PC:=r_PC+2;
  end;

  $37:
  begin
    r_F:=(r_F or f_C);
    clock:=clock+4;
    r_PC:=r_PC+1;
  end;
  
  $39: 
  begin
    r_L:=(r_L + (r_SP and $FF));
    r_H:=(r_H + ((r_SP shr 8) and $FF));
    if (r_L>$FF) then
    begin
      inc(r_H);
      r_L:=(r_L and $FF);
    end;
    if (r_H>$FF) then 
    begin
      r_H:=(r_H and $FF);
      r_F:=(r_F or f_C);
    end else begin
      r_F:=(r_F and (not f_C));
    end;
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $3A: 
  begin
    r_A:=do_read2(do_read(r_PC+1),do_read(r_PC+2));
    clock:=clock+13;
    r_PC:=r_PC+3;
  end;
  
  $3B: 
  begin
    if (r_SP<>0) then 
    begin
      r_SP:=r_SP-1;
    end
    else
    begin
      r_SP:=$FFFF;
    end;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $3C: 
  begin
    tmp2:=((r_A+1) and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));
    if (((tmp2 xor r_A) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;

  $3D:
  begin
    tmp2:=((r_A-1) and $FF);
    r_F:=(flags[tmp2] or (r_F and f_C));
    if (((tmp2 xor r_A) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $3E: 
  begin
    r_A:=do_read(r_PC+1);
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $3F: 
  begin
    r_F:=r_F xor f_C;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $40:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $49:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $52:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $5B:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $64:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $6D:  begin clock:=clock+5;    r_PC:=r_PC+1; end;
  $7F:
  begin
    clock:=clock+5;    r_PC:=r_PC+1;
  end;

  $41:
  begin
    r_B:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;

  $42:
  begin
    r_B:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $43: 
  begin
    r_B:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $44: 
  begin
    r_B:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $45: 
  begin
    r_B:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $46: 
  begin
    r_B:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $47: 
  begin
    r_B:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $48: 
  begin
    r_C:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $4A: 
  begin
    r_C:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $4B: 
  begin
    r_C:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $4C: 
  begin
    r_C:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $4D: 
  begin
    r_C:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $4E: 
  begin
    r_C:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $4F: 
  begin
    r_C:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $50: 
  begin
    r_D:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $51: 
  begin
    r_D:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $53: 
  begin
    r_D:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $54: 
  begin
    r_D:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $55: 
  begin
    r_D:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $56: 
  begin
    r_D:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $57: 
  begin
    r_D:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $58: 
  begin
    r_E:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $59: 
  begin
    r_E:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $5A: 
  begin
    r_E:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $5C: 
  begin
    r_E:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $5D: 
  begin
    r_E:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $5E: 
  begin
    r_E:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $5F: 
  begin
    r_E:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $60: 
  begin
    r_H:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $61: 
  begin
    r_H:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $62: 
  begin
    r_H:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $63: 
  begin
    r_H:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $65: 
  begin
    r_H:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $66: 
  begin
    r_H:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $67: 
  begin
    r_H:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $68: 
  begin
    r_L:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $69: 
  begin
    r_L:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $6A: 
  begin
    r_L:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $6B: 
  begin
    r_L:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $6C: 
  begin
    r_L:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $6E: 
  begin
    r_L:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $6F: 
  begin
    r_L:=r_A;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $70: 
  begin
    do_write2(r_L,r_H,r_B);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $71: 
  begin
    do_write2(r_L,r_H,r_C);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $72: 
  begin
    do_write2(r_L,r_H,r_D);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $73: 
  begin
    do_write2(r_L,r_H,r_E);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $74: 
  begin
    do_write2(r_L,r_H,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $75: 
  begin
    do_write2(r_L,r_H,r_L);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $76: 
  begin
   // cpu_halt_state:=true;
   // cpu_halt_reason:=halt_hlt;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $77: 
  begin
    do_write2(r_L,r_H,r_A);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $78: 
  begin
    r_A:=r_B;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $79: 
  begin
    r_A:=r_C;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $7A: 
  begin
    r_A:=r_D;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $7B: 
  begin
    r_A:=r_E;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $7C: 
  begin
    r_A:=r_H;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $7D: 
  begin
    r_A:=r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
    
  end;
  
  $7E: 
  begin
    r_A:=do_read2(r_L,r_H);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $80: 
  begin
    tmp2:=r_A+r_B;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_B) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=(tmp2 and $FF);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $81: 
  begin
    tmp2:=r_A+r_C;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_C) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $82: 
  begin
    tmp2:=r_A+r_D;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_D) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $83: 
  begin
    tmp2:=r_A+r_E;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_E) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $84: 
  begin
    tmp2:=r_A+r_H;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_H) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $85: 
  begin
    tmp2:=r_A+r_L;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_L) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $86: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=r_A+tmp1;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $87: 
  begin
    tmp2:=r_A+r_A;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_A) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $88: 
  begin
    tmp2:=r_A+r_B;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_B) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $89: 
  begin
    tmp2:=r_A+r_C;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_C) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $8A: 
  begin
    tmp2:=r_A+r_D;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_D) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $8B: 
  begin
    tmp2:=r_A+r_E;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_E) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $8C: 
  begin
    tmp2:=r_A+r_H;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_H) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=r_F or f_C;
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $8D: 
  begin
    tmp2:=r_A+r_L;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor r_L) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $8E: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=r_A+tmp1;
    if ((r_F and f_C)<>0) then  tmp2:=tmp2+1 else tmp2:=tmp2+0;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $8F: 
  begin
    tmp2:=r_A+r_A;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else tmp2:=tmp2+0;
    r_F:=flags[tmp2 and $FF];

    if (((tmp2  xor r_A  xor r_A) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;

    if (tmp2>$FF) then
    begin
      r_F:=(r_F or f_C);
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $90: 
  begin
    tmp2:=(r_A-r_B) and $FF;
    r_F:=flags[tmp2];

    if (r_A<r_B) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_B) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $91: 
  begin
    tmp2:=(r_A-r_C) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<r_C) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_C) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $92: 
  begin
    tmp2:=(r_A-r_D) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<r_D) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_D) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $93: 
  begin
    tmp2:=(r_A-r_E) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<r_E) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_E) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $94: 
  begin
    tmp2:=(r_A-r_H) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<r_H) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_H) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $95: 
  begin
    tmp2:=(r_A-r_L) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<r_L) then 
    begin
      r_F:=r_F or f_C;
    end;
    
    if (((tmp2  xor r_A  xor r_L) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $96: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=(r_A-tmp1) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<tmp1) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $97: 
  begin
    r_F:=flags[0];
    r_A:=0;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $98: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_B-tmp3) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<r_B+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_B) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $99: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_C-tmp3) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<(r_C+tmp3)) then
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_C) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $9A: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_D-tmp3) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<r_D+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_D) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $9B: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_E-tmp3) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<r_E+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_E) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $9C: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_H-tmp3) and $FF;
    r_F:=flags[tmp2];

    if (r_A<r_H+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_H) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $9D: 
  begin
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-r_L-tmp3) and $FF;
    r_F:=flags[tmp2];

    if (r_A<r_L+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_L) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $9E: 
  begin
    tmp1:=do_read2(r_L,r_H);
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-tmp1-tmp3) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<tmp1+tmp3) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    r_A:=tmp2;
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $9F: 
  begin
    if ((r_F and f_C)<>0) then tmp2:=$FF else tmp2:=0;
    r_F:=flags[tmp2];
    
    if (tmp2<>0) then 
    begin
      r_F:=r_F or (f_A or f_C);
    end;
    r_A:=tmp2;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $A0: 
  begin
    r_A:=r_A and r_B;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;

  $A1: 
  begin
    r_A:=r_A and r_C;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $A2: 
  begin
    r_A:=r_A and r_D;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $A3: 
  begin
    r_A:=r_A and r_E;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $A4: 
  begin
    r_A:=r_A and r_H;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $A5: 
  begin
    r_A:=r_A and r_L;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $A6: 
  begin
    tmp1:=do_read2(r_L,r_H);
    r_A:=r_A and tmp1;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $A7: 
  begin
    r_A:=r_A and r_A;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $A8: 
  begin
    r_A:=r_A xor r_B;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $A9: 
  begin
    r_A:=r_A  xor r_C;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;

  end;

  $AA:
  begin
    r_A:=r_A xor r_D;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $AB: 
  begin
    r_A:=r_A  xor r_E;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;

  end;

  $AC:
  begin
    r_A:=r_A  xor r_H;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $AD: 
  begin
    r_A:=r_A  xor r_L;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $AE: 
  begin
    tmp1:=do_read2(r_L,r_H);
    r_A:=r_A xor tmp1;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+7;
    r_PC:=r_PC+1;

  end;

  $AF:
  begin
    r_A:=0;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $B0: 
  begin
    r_A:=r_A or r_B;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;

  end;

  $B1:
  begin
    r_A:=r_A or r_C;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $B2: 
  begin
    r_A:=r_A or r_D;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;

  end;

  $B3:
  begin
    r_A:=r_A or r_E;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;

  end;

  $B4:
  begin
    r_A:=r_A or r_H;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $B5: 
  begin
    r_A:=r_A or r_L;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;

  end;

  $B6:
  begin
    tmp1:=do_read2(r_L,r_H);
    r_A:=r_A or tmp1;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+7;
    r_PC:=r_PC+1;

  end;

  $B7:
  begin
    r_A:=r_A or r_A;
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+4;
    r_PC:=r_PC+1;

  end;

  $B8:
  begin
    tmp2:=(r_A-r_B) and $FF;
    r_F:=flags[tmp2];

    if (r_A<r_B) then
    begin
      r_F:=(r_F or f_C);
    end;

    if (((tmp2  xor r_A  xor r_B) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    clock:=clock+4;
    r_PC:=r_PC+1;

  end;

  $B9:
  begin
    tmp2:=(r_A-r_C) and $FF;
    r_F:=flags[tmp2];

    if (r_A<r_C) then
    begin
      r_F:=(r_F or f_C);
    end;

    if (((tmp2  xor r_A  xor r_C) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    clock:=clock+4;
    r_PC:=r_PC+1;

  end;

  $BA:
  begin
    tmp2:=(r_A-r_D) and $FF;
    r_F:=flags[tmp2];

    if (r_A<r_D) then
    begin
      r_F:=(r_F or f_C);
    end;

    if (((tmp2  xor r_A  xor r_D) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    clock:=clock+4;
    r_PC:=r_PC+1;

  end;

  $BB:
  begin
    tmp2:=(r_A-r_E) and $FF;
    r_F:=flags[tmp2];

    if (r_A<r_E) then
    begin
      r_F:=(r_F or f_C);
    end;

    if (((tmp2  xor r_A  xor r_E) and $10)<>0) then
    begin
      r_F:=(r_F or f_A);
    end;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $BC: 
  begin
    tmp2:=(r_A-r_H) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<r_H) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_H) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $BD: 
  begin
    tmp2:=(r_A-r_L) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<r_L) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor r_L) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $BE: 
  begin
    tmp1:=do_read2(r_L,r_H);
    tmp2:=(r_A-tmp1) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<tmp1) then 
    begin
      r_F:=(r_F or f_C);
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=(r_F or f_A);
    end;
    clock:=clock+7;
    r_PC:=r_PC+1;
    
  end;
  
  $BF: 
  begin
    r_F:=flags[0];
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $C0: 
  begin
    
    if ((r_F and f_Z)<>0) then
     begin
      clock:=clock+5;
      r_PC:=r_PC+1;
     end
        else
     begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+(do_read(r_SP+1) shl 8);
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;
     end;
  end;

  $C1:
  begin
    r_C:=do_read(r_SP);
    r_B:=do_read(r_SP+1);
    r_SP:=(r_SP+2) and $FFFF;
    clock:=clock+10;
    r_PC:=r_PC+1;

  end;

  $C2:
  begin

    if ((r_F and f_Z)<>0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
    else
    begin
      r_PC:=do_read(r_PC+1)+((do_read(r_PC+2) shl 8));
      clock:=clock+10;
    end;
  end;

  $C3:
  begin
    r_PC:=do_read(r_PC+1)+((do_read(r_PC+2) shl 8));
    clock:=clock+10;
  end;

  $C4:
  begin
    if ((r_F and f_Z)<>0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
        else
        begin
      tmp1:=do_read(r_PC+1)+((do_read(r_PC+2) shl 8));
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;

    end;
  end;

  $C5:
  begin
    r_SP:=(r_SP-2) and $FFFF;
    do_write(r_SP,r_C);
    do_write(r_SP+1,r_B);
    clock:=clock+11;
    r_PC:=r_PC+1;

  end;

  $C6:
  begin
    tmp1:=do_read(r_PC+1);
    tmp2:=r_A+tmp1;
    r_F:=flags[tmp2 and $FF];

    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then
    begin
      r_F:=r_F or f_A;
    end;

    if (tmp2>$FF) then
    begin
      r_F:=r_F or f_C;
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+7;
    r_PC:=r_PC+2;

  end;

  $C7:
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=0*8;
    clock:=clock+11;

  end;

  $C8:
  begin

    if ((r_F and f_Z)=0) then

    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
        else
    begin

      r_PC:=do_read(r_SP);
      r_PC:=r_PC+(do_read(r_SP+1) shl 8);
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;

    end;
  end;
  
  $C9: 
  begin
    r_PC:=do_read(r_SP);
    r_PC:=r_PC+(do_read(r_SP+1) shl 8);
    r_SP:=(r_SP+2) and $FFFF;
    clock:=clock+11;
    
  end;
  
  $CA: 
  begin
    
    if ((r_F and f_Z)=0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
        else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;

    end;

  end;
  
  $CB: 
  begin
    if (signal_inv_opc()) then
           begin
           end
           else
           begin
            r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
            clock:=clock+10;
           end;
    
  end;
  
  $CC: 
  begin
    
    if ((r_F and f_Z)=0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end
  end;
  
  $CD: 
  begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    r_SP:=(r_SP-2) and $FFFF;
    r_PC:=r_PC+3;
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=tmp1;
    clock:=clock+17;
    
  end;
  
  $CE: 
  begin
    tmp1:=do_read(r_PC+1);
    tmp2:=r_A+tmp1;
    if ((r_F and f_C)<>0) then tmp2:=tmp2+1 else  tmp2:=tmp2+0;
    r_F:=flags[tmp2 and $FF];
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=r_F or f_A;
    end;
    
    if (tmp2>$FF) then 
    begin
      r_F:=r_F or f_C;
    end;
    r_A:=tmp2 and $FF;
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $CF: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=1*8;
    clock:=clock+11;
    
  end;
  
  $D0: 
  begin
    
    if ((r_F and f_C)<>0) then
    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
     else
     begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+(do_read(r_SP+1) shl 8);
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;
    end
  end;
  
  $D1: 
  begin
    r_E:=do_read(r_SP);
    r_D:=do_read(r_SP+1);
    r_SP:=(r_SP+2) and $FFFF;
    clock:=clock+10;
    r_PC:=r_PC+1;
    
  end;
  
  $D2: 
  begin
    if ((r_F and f_C)<>0) then

    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
     else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;
    end;
  end;
  
  $D3: 
  begin
    do_output(do_read(r_PC+1),r_A);
    clock:=clock+10;
    r_PC:=r_PC+2;
    
  end;
  
  $D4: 
  begin
    
    if ((r_F and f_C)<>0) then
   
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
     else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end;
  end;
  
  $D5: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    do_write(r_SP,r_E);
    do_write(r_SP+1,r_D);
    clock:=clock+11;
    r_PC:=r_PC+1;
    
  end;
  
  $D6: 
  begin
    tmp1:=do_read(r_PC+1);
    tmp2:=(r_A-tmp1) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<tmp1) then 
    begin
      r_F:=r_F or f_C;
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=r_F or f_A;
    end;
    r_A:=tmp2;
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $D7: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=2*8;
    clock:=clock+11;
    
  end;
  
  $D8: 
  begin
    
    if ((r_F and f_C)=0) then
    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
    else
    begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+do_read(r_SP+1) shl 8;
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;
    end;
  end;
  
  $D9: 
  begin
    if (signal_inv_opc()) then
           begin
           end
           else
           begin
            r_PC:=do_read(r_SP);
            r_PC:=r_PC+do_read(r_SP+1) shl 8;
            r_SP:=(r_SP+2) and $FFFF;
            clock:=clock+11;
           end;
    
  end;
  
  $DA: 
  begin
    
    if ((r_F and f_C)=0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
     else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;
    end;
  end;
  
  $DB: 
  begin
    r_A:=do_input(do_read(r_PC+1));
    clock:=clock+10;
    r_PC:=r_PC+2;
    
  end;
  
  $DC: 
  begin
    
    if ((r_F and f_C)=0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end;
  end;
  
  $DD:    begin
    if (signal_inv_opc()) then
    begin

    end
    else
    begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    r_SP:=(r_SP-2) and $FFFF;
    r_PC:=r_PC+3;
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=tmp1;
    clock:=clock+17;
    end;
  end;


  $ED:    begin
    if (signal_inv_opc()) then
    begin

    end
    else
    begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    r_SP:=(r_SP-2) and $FFFF;
    r_PC:=r_PC+3;
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=tmp1;
    clock:=clock+17;
    end;
  end;


  $FD:
  begin
    if (signal_inv_opc()) then  
    begin

    end
    else
    begin
    tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
    r_SP:=(r_SP-2) and $FFFF;
    r_PC:=r_PC+3;
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=tmp1;
    clock:=clock+17;
    end;
  end;

  $DE: 
  begin
    tmp1:=do_read(r_PC+1);
    if ((r_F and f_C)<>0) then tmp3:=1 else tmp3:=0;
    tmp2:=(r_A-tmp1-tmp3) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<tmp1+tmp3) then 
    begin
      r_F:=r_F or f_C;
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=r_F or f_A;
    end;
    r_A:=tmp2;
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $DF: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=3*8;
    clock:=clock+11;
    
  end;
  
  $E0: 
  begin
    if ((r_F and f_P)<>0) then
    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
    else
    begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+do_read(r_SP+1) shl 8;
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;
    end ;
    
  end;
  
  $E1: 
  begin
    r_L:=do_read(r_SP);
    r_H:=do_read(r_SP+1);
    r_SP:=(r_SP+2) and $FFFF;
    clock:=clock+10;
    r_PC:=r_PC+1;
    
  end;
  
  $E2: 
  begin
    
    if ((r_F and f_P)<>0) then
    
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
    else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;

    end;
    
  end;
  
  $E3: 
  begin
    tmp1:=do_read(r_SP);
    do_write(r_SP,r_L);
    r_L:=tmp1;
    tmp1:=do_read(r_SP+1);
    do_write(r_SP+1,r_H);
    r_H:=tmp1;
    clock:=clock+18;
    r_PC:=r_PC+1;
    
  end;
  
  $E4: 
  begin
    
    if ((r_F and f_P)<>0) then
    
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;

    end;
    
  end;
  
  $E5: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    do_write(r_SP,r_L);
    do_write(r_SP+1,r_H);
    clock:=clock+11;
    r_PC:=r_PC+1;
    
  end;
  
  $E6: 
  begin
    r_A:=r_A and do_read(r_PC+1);
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $E7: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=4*8;
    clock:=clock+11;
    
  end;
  
  $E8: 
  begin
    if ((r_F and f_P)=0) then
    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
     else
    begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+do_read(r_SP+1) shl 8;
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;

    end;
    
  end;
  
  $E9: 
  begin
    r_PC:=(r_H shl 8)+r_L;
    clock:=clock+5;
  end;
  
  $EA: 
  begin
    
    if ((r_F and f_P)=0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;  
    end
    else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;

    end;
  end;
  
  $EB: 
  begin
    tmp1:=r_D;
    r_D:=r_H;
    r_H:=tmp1;
    tmp1:=r_E;
    r_E:=r_L;
    r_L:=tmp1;
    clock:=clock+4;
    r_PC:=r_PC+1;
    
  end;
  
  $EC: 
  begin
    if ((r_F and f_P)=0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end;
  end;
  
  $EE: 
  begin
    r_A:= r_A xor do_read(r_PC+1);
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+7;
    r_PC:=r_PC+2;
  end;
  
  $EF: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=5*8;
    clock:=clock+11;
  end;
  
  $F0: 
  begin
    if ((r_F and f_S)<>0) then
     begin
      clock:=clock+5;
      r_PC:=r_PC+1;
     end
     else
     begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+(do_read(r_SP+1) shl 8);
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;
    end;
  end;
  
  $F1: 
  begin
    r_F:=do_read(r_SP);
    r_A:=do_read(r_SP+1);
    r_SP:=(r_SP+2) and $FFFF;
    clock:=clock+10;
    r_PC:=r_PC+1;
  end;
  
  $F2: 
  begin
    if ((r_F and f_S)<>0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
    else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;
    end;
  end;
  
  $F4: 
  begin
    
    if ((r_F and f_S)<>0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end;
  end;
  
  $F5: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    do_write(r_SP,r_F);
    do_write(r_SP+1,r_A);
    clock:=clock+11;
    r_PC:=r_PC+1;
    
  end;
  
  $F6: 
  begin
    r_A:=r_A or do_read(r_PC+1);
    r_F:=flags[r_A] or (r_F and f_A);
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $F7: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=6*8;
    clock:=clock+11;
    
  end;
  
  $F8: 
  begin
    if ((r_F and f_S)=0) then
    begin
      clock:=clock+5;
      r_PC:=r_PC+1;
    end
     else
    begin
      r_PC:=do_read(r_SP);
      r_PC:=r_PC+(do_read(r_SP+1) shl 8);
      r_SP:=(r_SP+2) and $FFFF;
      clock:=clock+11;

    end;
  end;
  
  $F9: 
  begin
    r_SP:=(r_H shl 8)+r_L;
    clock:=clock+5;
    r_PC:=r_PC+1;
  end;
  
  $FA: 
  begin
    if ((r_F and f_S)=0) then
    begin
      clock:=clock+10;
      r_PC:=r_PC+3;
    end
     else
    begin
      r_PC:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      clock:=clock+10;
    end;
  end;
  
  $FC: 
  begin
    if ((r_F and f_S)=0) then
    begin
      clock:=clock+11;
      r_PC:=r_PC+3;
    end
    else
    begin
      tmp1:=do_read(r_PC+1)+(do_read(r_PC+2) shl 8);
      r_SP:=(r_SP-2) and $FFFF;
      r_PC:=r_PC+3;
      do_write(r_SP,r_PC and $FF);
      do_write(r_SP+1,(r_PC shr 8) and $FF);
      r_PC:=tmp1;
      clock:=clock+17;
    end;
  end;
  
  $FE: 
  begin
    tmp1:=do_read(r_PC+1);
    tmp2:=(r_A-tmp1) and $FF;
    r_F:=flags[tmp2];
    
    if (r_A<tmp1) then 
    begin
      r_F:=r_F or f_C;
    end;
    
    if (((tmp2  xor r_A  xor tmp1) and $10)<>0) then 
    begin
      r_F:=r_F or f_A;
    end;
    clock:=clock+7;
    r_PC:=r_PC+2;
    
  end;
  
  $FF: 
  begin
    r_SP:=(r_SP-2) and $FFFF;
    inc(r_PC);
    do_write(r_SP,r_PC and $FF);
    do_write(r_SP+1,(r_PC shr 8) and $FF);
    r_PC:=7*8;
    clock:=clock+11;
    
  end
  else
  begin
     // cpu_halt_state:=true;
     // cpu_halt_reason:=halt_inv;
  end;

end;
end;
end;


procedure TMainFormEmu.draw_screen;   //  video    ()

var
  i,vertX,gorY : word;
begin
  i:=0;
  vertX:=0;
  gorY:=0;
  while (i<$4000) do
  begin
   if video[i]<>VideoDirty[i] then //  ,    
        begin
          //WriteVRAM(video[i],vertX,gorY);   //     
        if not N7.Checked then  //   
          begin
          gamecanvas.Canvas.Pixels[vertX,gorY]:=  SuperColor[ports[$C1],video[i],1];
          gamecanvas.Canvas.Pixels[vertX+1,gorY]:=SuperColor[ports[$C1],video[i],2];
          gamecanvas.Canvas.Pixels[vertX+2,gorY]:=SuperColor[ports[$C1],video[i],3];
          gamecanvas.Canvas.Pixels[vertX+3,gorY]:=SuperColor[ports[$C1],video[i],4];
          end
          else
          begin
          gamecanvas.Canvas.Pixels[vertX,gorY]:=  GrayTV(SuperColor[ports[$C1],video[i],1]);
          gamecanvas.Canvas.Pixels[vertX+1,gorY]:=GrayTV(SuperColor[ports[$C1],video[i],2]);
          gamecanvas.Canvas.Pixels[vertX+2,gorY]:=GrayTV(SuperColor[ports[$C1],video[i],3]);
          gamecanvas.Canvas.Pixels[vertX+3,gorY]:=GrayTV(SuperColor[ports[$C1],video[i],4]);
          end;

        end;
    vertX:=vertX+4;
    if vertX>=256 then begin vertX:=0; gorY:=gorY+1; end;
    inc(i);
  end;
{$R-}
for I := 0 to $4000 do VideoDirty[i]:= video[i];  //   
{$R+}
if FullScreen1.Checked then                        //     
MainFormEmu.Canvas.StretchDraw(rect(0,ToolBar1.Height,MainFormEmu.Width-16,MainFormEmu.Height-58), gamecanvas)
else
MainFormEmu.Canvas.Draw(0,ToolBar1.Height,gamecanvas);
end;


procedure TMainFormEmu.VRAMTest(c1,b:Byte);

Var

pix1,pix2,pix3,pix4:byte;
begin
   pix1:=0; pix2:=0; pix3:=0; pix4:=0;
  if (b and 128)=128 then pix1:=pix1+1;
  if (b and 8)=8     then pix1:=pix1+2;
  if (b and 64)=64   then pix2:=pix2+1;
  if (b and 4)=4     then pix2:=pix2+2;
  if (b and 32)=32   then pix3:=pix3+1;
  if (b and 2)=2     then pix3:=pix3+2;
  if (b and 16)=16   then pix4:=pix4+1;
  if (b and 1)=1     then pix4:=pix4+2;

  SuperColor[c1,b,1]:=compute_color_index(c1,Mycolor[pix1]);

  SuperColor[c1,b,2]:=compute_color_index(c1,Mycolor[pix2]);

  SuperColor[c1,b,3]:=compute_color_index(c1,Mycolor[pix3]);

  SuperColor[c1,b,4]:=compute_color_index(c1,Mycolor[pix4]);

end;

procedure TMainFormEmu.CalculateColor;
var
  I,j: Integer;
begin
for I := 0 to 255 do
   for j := 0 to 255 do
    begin
       VRAMTest(i, j);
    end;
end;


function TMainFormEmu.compute_color_index(port : byte; color : tcolor): tcolor;  //      

begin
  Result:=ClBLACK;
  if ((port and $40)<>0) then Result:= (Result xor ClBLUE);
  if ((port and $20)<>0) then Result:= (Result xor clLime);
  if ((port and $10)<>0) then Result:= (Result xor ClRED);
  case color of
  clBLACK:
     begin
       if ((port and $08)=0) then
         begin
           Result:= (Result xor CLRED);
         end;
       if ((port and $04)=0) then
         begin
          Result:= (Result xor ClBLUE);
         end;
      end;
   clLime: begin
      Result:= (Result xor clLime);
      end;
   clred:  begin
       Result:= (Result xor ClRED);
       if ((port and $02)=0) then
           begin
             //Result:= (Result xor ClGREEN);
             Result:= (Result xor clLime);
           end;
        end;
    clBLUE: begin
         Result:= (Result xor ClBLUE);
         if ((port and $01)=0) then
            begin
             Result:= (Result xor ClRED);
            end;
       end;
end;
   // result:= ((Result and $07) shl 13) or ((Result and $38) shl 5) or ((Result and $C0) shr 3);
end;



procedure TMainFormEmu.WriteVRAM(b:Byte;x,y: integer);  //   gamecanvas   ,     1

Var
pix1,pix2,pix3,pix4:byte;
begin
  pix1:=0; pix2:=0; pix3:=0; pix4:=0;        //      
  if (b and 128)=128 then pix1:=pix1+1;
  if (b and 8)=8     then pix1:=pix1+2;
  if (b and 64)=64   then pix2:=pix2+1;
  if (b and 4)=4     then pix2:=pix2+2;
  if (b and 32)=32   then pix3:=pix3+1;
  if (b and 2)=2     then pix3:=pix3+2;
  if (b and 16)=16   then pix4:=pix4+1;
  if (b and 1)=1     then pix4:=pix4+2;
  if N7.Checked then  //   
    begin
      gamecanvas.Canvas.Pixels[x,y] := GrayTV(compute_color_index(ports[$C1],Mycolor[pix1]));
      gamecanvas.Canvas.Pixels[x+1,y]:=GrayTV(compute_color_index(ports[$C1],Mycolor[pix2]));
      gamecanvas.Canvas.Pixels[x+2,y]:=GrayTV(compute_color_index(ports[$C1],Mycolor[pix3]));
      gamecanvas.Canvas.Pixels[x+3,y]:=GrayTV(compute_color_index(ports[$C1],Mycolor[pix4]));
    end
    else
    begin
     gamecanvas.Canvas.Pixels[x,y]:=  compute_color_index(ports[$C1],Mycolor[pix1]);
     gamecanvas.Canvas.Pixels[x+1,y]:=compute_color_index(ports[$C1],Mycolor[pix2]);
     gamecanvas.Canvas.Pixels[x+2,y]:=compute_color_index(ports[$C1],Mycolor[pix3]);
     gamecanvas.Canvas.Pixels[x+3,y]:=compute_color_index(ports[$C1],Mycolor[pix4]);
     end;
end;



procedure TMainFormEmu.FirstPusk; // 
 begin
 //    
 gamecanvas:=tbitmap.Create;
 gamecanvas.Width:=256;
 gamecanvas.Height:=256;

  ResetComp; //   
  TimerMain.Enabled:=true; //   
end;

function TMainFormEmu.readmask (keynum: word): word;    //  
begin
result:= $72FF;
case keynum of
      8: begin result:= $23FF end;  // BCK
     13: begin result:= $13FF end;  // ENTER
	   16: begin result:= $70FF end;  // SHIFT
     32: begin result:= $30FF end;  // SPC

     37: begin result:= $FF32 end;  //  <-
     38: begin result:= $FF31 end;  //  UP
     39: begin result:= $FF30 end;  //  ->
     40: begin result:= $FF33 end;  //  DOWN

     48: begin result:= $06FF end;  //   0
	   49: begin result:= $47FF end;  //   1
	   50: begin result:= $46FF end;  //   2
   	 51: begin result:= $45FF end;  //   3
  	 52: begin result:= $44FF end;  //   4
   	 53: begin result:= $43FF end;  //   5
   	 54: begin result:= $00FF end;  //   6
  	 55: begin result:= $01FF end;  //   7
  	 56: begin result:= $02FF end;  //   8
  	 57: begin result:= $07FF end;  //   9

  	 65: begin result:= $64FF end;  //   A
     66: begin result:= $31FF end;  //   B
     67: begin result:= $57FF end;  //   C
     68: begin result:= $27FF end;  //   D
     69: begin result:= $54FF end;  //   E
     70: begin result:= $67FF end;  //   F
     71: begin result:= $10FF end;  //   G
  	 72: begin result:= $16FF end;  //   H
  	 73: begin result:= $75FF end;  //   I
  	 74: begin result:= $52FF end;  //   J
     75: begin result:= $55FF end;  //   K
   	 76: begin result:= $22FF end;  //   L
  	 77: begin result:= $76FF end;  //   M
  	 78: begin result:= $53FF end;  //   N
   	 79: begin result:= $21FF end;  //   O
   	 80: begin result:= $63FF end;  //   P
  	 81: begin result:= $71FF end;  //   Q
     82: begin result:= $20FF end;  //   R
   	 83: begin result:= $77FF end;  //   S
   	 84: begin result:= $74FF end;  //   T
     85: begin result:= $56FF end;  //   U
  	 86: begin result:= $26FF end;  //   V
  	 87: begin result:= $65FF end;  //   W
   	 88: begin result:= $73FF end;  //   X
   	 89: begin result:= $66FF end;  //   Y
  	 90: begin result:= $17FF end;  //   Z

  	 107: begin result:= $05FF end;  //   =/+ -> =/-
  	 109: begin result:= $05FF end;  //   -/_ -> =/-

  	 114: begin result:= $FF23 end;  // F3
  	 115: begin result:= $FF22 end;  // F4
   	 116: begin result:= $FF21 end;  // F5

  	 36: begin result:= $FF20 end;  // Home

  	 219: begin result:= $11FF end;  //   [
  	 221: begin result:= $12FF end;  //   ]
  	 190: begin result:= $24FF end;  //   .
   	 188: begin result:= $37FF end;  //   ,
   	 192: begin result:= $72FF end;  //
end;

end;

procedure TMainFormEmu.FormActivate(Sender: TObject);
begin
if FPusk then    //     
    begin
    FPusk:=false;
    FirstPusk;
    end;
end;

procedure TMainFormEmu.FormCreate(Sender: TObject);
begin
DragAcceptFiles(MainFormEmu.Handle, true);   //     :)
CalculateColor;
FPusk:=true; //   
English1Click(Sender);
end;

procedure TMainFormEmu.FormDestroy(Sender: TObject);
begin
DragAcceptFiles(Handle, False);
ServiceThread.Free;
end;

procedure TMainFormEmu.FormKeyDown(Sender: TObject; var Key: Word;  // 
  Shift: TShiftState);
begin
    kbd(readmask(key),true);  // 
    i8080_do_opcodes(opcodes_to_run);
end;

procedure TMainFormEmu.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   kbd(readmask(key),false); // 
end;

procedure TMainFormEmu.FullScreen1Click(Sender: TObject);
begin
FullScreen1.Checked:= not FullScreen1.Checked;
if not FullScreen1.Checked then
MainFormEmu.Canvas.FillRect(rect(0,0,MainFormEmu.Width,MainFormEmu.Height));

end;

procedure TMainFormEmu.TimerMainTimer(Sender: TObject);  //  
var
j,a: word;
i: integer;
s: string;
begin
if (pause) then  //     :)
  begin
    exit;
  end;
 i8080_do_opcodes(opcodes_to_run);
 draw_screen;
 if clock<100000 then
  begin
    playTone;
  end;
 speaked:= 0;
 if DebuggerForm.Visible then               //   
  begin
  DebuggerForm.label1.Caption:='r_B:'+inttostr(r_B);
  DebuggerForm.label2.Caption:='r_C:'+ inttostr(r_C );
  DebuggerForm.label3.Caption:='r_D:'+ inttostr(r_D );
  DebuggerForm.label4.Caption:='r_E:'+ inttostr(r_E );
  DebuggerForm.label5.Caption:='r_H:'+ inttostr(r_H );
  DebuggerForm.label6.Caption:='r_L:'+ inttostr(r_L );
  DebuggerForm.label7.Caption:='r_A:'+ inttostr(r_A );
  DebuggerForm.label8.Caption:='r_F:'+ inttostr(r_F );
  DebuggerForm.label9.Caption:='r_PC:'+ inttostr(r_PC );
  DebuggerForm.label10.Caption:='r_SP:'+ inttostr(r_SP );
  DebuggerForm.label11.Caption:='clock:'+ inttostr(clock);
if DebuggerForm.CheckBoxMem.Checked then
 begin
 j:=0;
 a:=DebuggerForm.StringGrid1.toprow;
 s:='';
 for  i:=(DebuggerForm.StringGrid1.toprow*$10-$10) to (DebuggerForm.StringGrid1.toprow*$10-$10+DebuggerForm.StringGrid1.VisibleRowCount*$10) do
     begin
     if i>65535 then exit;
      j:=j+1;
      if j>15 then
      begin
        DebuggerForm.StringGrid1.Cells[j,a]:=inttohex(memory[i],2);
        if (memory[i]>31) and (memory[i]<128) then s:=s+chr(memory[i]) else s:=s+'.';
        DebuggerForm.StringGrid1.Cells[j+1,a]:=s;
        j:=0;
        a:=a+1;
        s:='';
      end
      else
        begin
        DebuggerForm.StringGrid1.Cells[j,a]:=inttohex(memory[i],2);
        if (memory[i]>31) and (memory[i]<128) then s:=s+chr(memory[i]) else s:=s+'.';
       // s:=s+chr(memory[i]);
        end;
     end;
     end;
  end;
end;

procedure TMainFormEmu.ResetComp;
begin
 r_B := 0;  //  
 r_C := 0;
 r_D := 0;
 r_E := 0;
 r_H := 0;
 r_L := 0;
 r_A := 0;
 r_F := 0;
 r_PC := 0;
 r_SP := 0;

 clock := 0; //  

 halt_inv := 1;
 halt_opc := 2;
 halt_hlt := 3;

 halt_bpx := 4;
 halt_bpr := 5;
 halt_bpw := 6;
 halt_bpi := 7;
 halt_bpo := 8;



 pause := false;
 FPS := 50;


 speaked := 0;

 f_S := (1 SHL 7);
 f_Z :=( 1 SHL 6);
 f_5 := (1 SHL 5);
 f_A := (1 SHL 4);
 f_3 := (1 SHL 3);
 f_P := (1 SHL 2);
 f_1 := (1 SHL 1);
 f_C := (1 SHL 0);

 BasicStack := $AFC1;
 BasicHotEntry := $02FD;
 BasicProgBegin := $0243;
 BasicProgEnd := $0245;


  fillchar(VideoDirty,sizeof(VideoDirty),257);

  soundEnabled := false;
 // opcodes_to_run := round ((1411200*4)/FPS);
  opcodes_to_run := round ((1411200*2)/FPS);
  curSnd := 0;
  restClock := 0;
  init_memory();
  reset1();
  load_bios();
  i8080_do_opcodes(0);
end;

procedure TMainFormEmu.ResetCPU1Click(Sender: TObject);
begin
ResetComp;
end;


function TMainFormEmu.GrayTV(RGBColor : TColor) : TColor;  //    
var
Gray : byte;
begin
Gray := Round((0.30 * GetRValue(RGBColor)) +
               (0.59 * GetGValue(RGBColor)) +
               (0.11 * GetBValue(RGBColor )));
Result := RGB(Gray, Gray, Gray);                 //    :-)
end;


procedure TMainFormEmu.English1Click(Sender: TObject);
begin
English1.Checked:=true;
Russian1.Checked:=false;
MainFormEmu.Caption:='PK-01 Lvov emulator';

//DebuggerForm.TabSheet1.Caption:='Assembler';
//DebuggerForm.TabSheet2.Caption:='Find-replace in memory';


N1.Caption:='File';
N2.Caption:='Open';
ResetCPU1.Caption:='Reset CPU';
N11.Caption:='Pause';
N4.Caption:='Exit';

N5.Caption:='Setup';
N7.Caption:='Balck-and-white TV';
N10.Caption:='Keyboard';
N13.Caption:='Sound';
N15.Caption:='Language';

N17.Caption:='About';
end;

procedure TMainFormEmu.Russian1Click(Sender: TObject);
begin
Russian1.Checked:=true;
English1.Checked:=false;
MainFormEmu.Caption:='-01  ';

//DebuggerForm.TabSheet1.Caption:='';
//DebuggerForm.TabSheet2.Caption:='-  ';

N1.Caption:='';
N2.Caption:='';
ResetCPU1.Caption:='Reset CPU';
N11.Caption:='';
N4.Caption:='';

N5.Caption:='';
N7.Caption:=' ';
N10.Caption:='';
N13.Caption:='';
N15.Caption:=' ';

N17.Caption:=' ';
end;


// ###################################################  :-) ##############################################################


procedure TMainFormEmu.putSound(bt : byte);
begin
  if (((bt xor ports[$C2]) and 1)<>0) then
  begin
    speaker[speaked]:=clock;
    speaked:=speaked+1;
  end;
end;

procedure TMainFormEmu.playTone();
var
tickPos,speakerPos,i: integer;
Buffer: array of byte;
begin
for I := 0 to 2000 do soundData[i]:=0;
  tickPos:=0-restClock;
  speakerPos:=0;
  i:=0;
  while (i<2000) do // 2000   soundData
    begin
     if (speakerPos<speaked) and (tickPos>=speaker[speakerPos]) then
      begin
       curSnd:=255-curSnd;
       inc(speakerPos);
      end;
    tickPos:=tickPos+32;
    soundData[i]:=curSnd;
    inc(i);
  end;
  restClock:=(clock+restClock) mod 32;
 if N13.Checked then
       begin
         //ServiceThread:= TserviceThread.Create(false);
        // PlayBuffer(soundData);    //     :-)
       end;
end;

procedure TMainFormEmu.enableSound;
begin
	soundEnabled:= true;
end;

procedure TMainFormEmu.PlayBuffer(Buffer: array of byte);  //  
{var Err: integer;
hEvent: Thandle; }
begin
{ with header do
   begin
     wFormatTag := WAVE_FORMAT_PCM;  //  
     nChannels := 1;    // 
     nSamplesPerSec := 44100;  //   44.1 
     wBitsPerSample := 8; //  8 
     nBlockAlign := nChannels * (wBitsPerSample div 8);
     nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
     cbSize := 0;
   end;
// if Opened = true then stopPlay;
   hEvent:=CreateEvent(nil,false,false,nil);
   if WaveOutOpen(addr(waveOut), 0, @header, hEvent, 0, CALLBACK_WINDOW) <> MMSYSERR_NOERROR then
      begin
        CloseHandle(hEvent);
        Exit;
      end;
   pBuf := GlobalAlloc(GMEM_MOVEABLE and GMEM_SHARE, length(Buffer));
   pBuffer := GlobalLock(pBuf);
   with outHdr do
     begin
      lpData := PBuffer;
      dwBufferLength := length(Buffer);
      dwUser := 0;
      dwFlags := 0;
      dwLoops := 0
     end;
   err:= WaveOutPrepareHeader(waveOut, @outHdr, sizeof(outHdr));
   if Err <> 0 then Exit;
   copyMemory(pBuffer, @Buffer, length(Buffer));

   err:= WaveOutWrite(waveOut, @outHdr, sizeof(outHdr));
   if Err <> 0 then Exit;

   waveOutReset(waveOut);
   waveOutUnprepareHeader(waveOut,@outHdr,sizeof(wavehdr));
   waveOutClose(waveOut);  }
end;

procedure Tservicethread.Execute;
var
    Err: integer;
    header : TWaveFormatEx;
    waveOut : hWaveOut;
    outHdr : TWaveHdr;
    pBuf : tHandle;
    pBuffer : pointer;
    hEvent: Thandle;
begin
 with header do
   begin
     wFormatTag := WAVE_FORMAT_PCM;  //  
     nChannels := 1;    // 
     nSamplesPerSec := 44100;  //   44.1 
     wBitsPerSample := 8; //  8 
     nBlockAlign := nChannels * (wBitsPerSample div 8);
     nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;
     cbSize := 0;
   end;
// if Opened = true then stopPlay;
   hEvent:=CreateEvent(nil,false,false,nil);
   if WaveOutOpen(addr(waveOut), 0, @header, hEvent, 0, CALLBACK_WINDOW) <> MMSYSERR_NOERROR then
      begin
        CloseHandle(hEvent);
        Exit;
      end;
   pBuf := GlobalAlloc(GMEM_MOVEABLE and GMEM_SHARE, length(soundData));
   pBuffer := GlobalLock(pBuf);
   with outHdr do
     begin
      lpData := PBuffer;
      dwBufferLength := length(soundData);
      dwUser := 0;
      dwFlags := 0;
      dwLoops := 0
     end;
   WaveOutPrepareHeader(waveOut, @outHdr, sizeof(outHdr));
   //copyMemory(pBuffer, @soundData, length(soundData));

// while not terminated do
  // begin
    WaveOutWrite(waveOut, @outHdr, sizeof(outHdr));
    WaitForSingleObject(hEvent,INFINITE);
 //  end;

   waveOutReset(waveOut);
   waveOutUnprepareHeader(waveOut,@outHdr,sizeof(wavehdr));
   waveOutClose(waveOut);
end;

end.
